-----------------------------------------------------------------------------------------
-- PLAY SCENARIO
-----------------------------------------------------------------------------------------
-- modes: 1-standard, 2-kill commander, 3-capture tower, 4-hold tower until #date
-- [1]view, [2]whose turn, [3]selected?, [4]day/week/month/year, [5]castle panel (left), [6]hero panel, [7]mode, [8]cords for mode 3/4
sc_map = {}
sc_cities = {}
sc_heroes = {}
sc_players = {}
sc_resources = {}
sc_all = {} --{who1, who2, untilDate, vassalGold, vassalRes, breakCost} -- vassal cost FROM 1 TO 2
sc_all_o = {} --{who1, who2, untilDate, vassalGold, vassalRes, offerGold, offerRes}
buildingOn = 0
dontMoveCamera = 0
local scn_all = {"polandball", "greeceball", "byzantineball", "serbiaball", "russiaball", "britainball", "italyball", "franceball", "spainball", "gambiaball"}

local tm_heroes = {
	--{id = #tm_heroes+1, hid = hid, owner = owner, level = 1, xp = 0, army = {}, items = {}, pos = {x = #tm_heroes+1, y = #tm_heroes+1}},
	}
function tmAddPlayer( owner, hid )
	local ct = (heroes[hid].allowed ~= nil and heroes[hid].allowed) or heroes[hid].country
	local h = heroes__[hid]
	local spells2 = {}
	if h.att > 9 then
		table.insert(spells2, 13)
	end
	if h.def > 9 then
		table.insert(spells2, 5)
	end
	if h.int > 9 then
		table.insert(spells2, 14)
	end
	tm_heroes[#tm_heroes+1] = {id = #tm_heroes+1, hid = hid, owner = owner, level = 1, xp = 0, army = {[1] = {ct, 1, 13}, [2] = {ct, 2, 5}}, items = {}, pocket = {}, pos = {x = #tm_heroes+1, y = #tm_heroes+1}, stamina = 5, mana = 0, spells = spells2}
end
local PtC = {}
function changePtC(event) -- Player to Comptuer switch/button
	if event.phase == "ended" then
		local id = event.target.idd
		PtC[id] = PtC[id]+1 
		if PtC[id] == 2 then PtC[id] = 0 end
		scenarioSel1()
	end
end
local me_c2 = {"ground", "environment", "building"}

function scenarioSel1()
	cleanImg()
	displayNewImage( "img/background/menu_8.png", display.contentCenterX, display.contentCenterY )
	local a = gui(480, 360, display.contentCenterX, display.contentCenterY, "", 1)
	a.alpha = 0.5
	local function exitToMenu(event)	if event.phase == "ended" then	menuDs() end end
	displayNewImage("img/exit.png", display.contentCenterX-200, 40):addEventListener("touch", exitToMenu)
	displayNewImage("img/accept.png", display.contentCenterX+200, 40):addEventListener("touch", scenarioStart)
	displayNewText( maps[arrows[13]+1][1], display.contentCenterX, display.contentCenterY-140, "Arial", 20)
	displayArrows(display.contentCenterX, display.contentCenterY-140, 4, scenarioSel1, 13, #maps-1, {1,1,0})
	gui(240, 60, 240, 285, "", 1)
	displayNewText( maps[arrows[13]+1][2], 240, 285, "Arial", 12)
	local cities = loadTable("map_"..maps[arrows[13]+1][3])[2]
	local p_array = {}
	for k,v in pairs(cities)do
		if isInArray(v.owner, p_array) == false then
			p_array[v.owner] = v.owner
		end
	end
	displayNewText( "Country", 180, 70, "Arial", 20)
	displayNewText( "Hero", 300, 70, "Arial", 20)
	if #PtC == 0 then
		for i = 1, #p_array do
			table.insert(PtC, 0)
		end
	end
	for i = 1, #p_array do
		local pl = p_array[i]
		local h_array = {}
		for j = 1, #heroes do
			if heroes[j].country == scn_all[arrows[26+(pl*2)]+1] or (heroes[j].allowed ~= nil and heroes[j].allowed == scn_all[arrows[26+(pl*2)]+1]) then
				table.insert(h_array, j)
			end
		end
		local pnames = {"Player", "Easy (CPU)", "Normal (CPU)", "Hard (CPU)"}
		local p = displayNewText( pnames[PtC[i]+1].." "..pl, 80, 70+(i*40), "Arial", 18)
		p.idd = i
		p:addEventListener("touch", changePtC)
		displayArrows(180, 70+(i*40), 1, scenarioSel1, 26+(pl*2), #scn_all-1, {1,1,0})
		displayNewImage("img/countries/"..scn_all[arrows[26+(pl*2)]+1].."/1.png", 180, 70+(i*40))

		if #h_array < arrows[27+(pl*2)]+1 then
			arrows[27+(pl*2)] = 0
		end
		displayArrows(300, 70+(i*40), 1, scenarioSel1, 27+(pl*2), #h_array-1, {1,1,0})
		if #h_array > 0 then
			displayNewImage("img/countries/"..heroes[h_array[arrows[27+(pl*2)]+1]].country.."/1.png", 300, 70+(i*40))
			for j = 1, #heroes[h_array[arrows[27+(pl*2)]+1]].attr do
				displayNewImage("img/attributes/"..heroes[h_array[arrows[27+(pl*2)]+1]].attr[j]..".png", 300, 70+(i*40))
			end
		end
	end
end
function scenarioStart(event)
	if event.phase == "ended" then

		sc_local = {{5,5}, 1, {0, 0}, {1, 1, 1, 1}, 1, 1, 4, {0, 0}}
		sc_map = {}
		sc_cities = {}
		sc_heroes = {}
		sc_players = {}
		sc_resources = {}
		buildingOn = 0
		sc_all = {}
		sc_all_o = {}
		tm_heroes = {}

		sc_map = loadTable("map_"..maps[arrows[13]+1][3])[1]
		sc_cities = loadTable("map_"..maps[arrows[13]+1][3])[2]
		sc_local[7] = loadTable("map_"..maps[arrows[13]+1][3])[3][1] or 1
		sc_local[8] = loadTable("map_"..maps[arrows[13]+1][3])[3][2] or {0, 0}
		for x = 1, #sc_map do
			for y = 1, #sc_map[x] do
				if sc_map[x][y][3] ~= nil and resources[sc_map[x][y][3]] ~= nil then
					table.insert(sc_resources, {x, y})
				end
			end
		end
		local p = 0
		local p_array = {}
		for k,v in pairs(sc_cities)do
			if isInArray(v.owner, p_array) == false then
				p = p+1
				table.insert(p_array, v.owner)
			end
		end
		if p > 1 then
			for i = 1, p do
				local h_array = {}
				for j = 1, #heroes do
					if heroes[j].country == scn_all[arrows[26+(i*2)]+1] or (heroes[j].allowed ~= nil and heroes[j].allowed == scn_all[arrows[26+(i*2)]+1]) then
						table.insert(h_array, j)
					end
				end
				table.insert(sc_players, {id = i, country = scn_all[arrows[25+(i*2)]+1], money = 5000, minerals = 250, alive = 1, type = PtC[i]})
				tmAddPlayer( i, h_array[arrows[27+(i*2)]+1] )
			end
			sc_heroes = nil
			sc_heroes = deepcopy(tm_heroes)
			for h = 1, #sc_heroes do
				for x = 1, #sc_map do
					for y = 1, #sc_map[x] do
						if sc_map[x][y][3] == 1 then
							if sc_map[x][y][6] == sc_heroes[h].owner then
								sc_heroes[h].pos.x = x
								sc_heroes[h].pos.y = y+1
								sc_heroes[h].commander = 1
								break
							end
						end
					end
				end
			end
			for k,v in pairs(sc_cities)do
				sc_cities[k].country = scn_all[arrows[26+(v.owner*2)]+1]
				sc_cities[k].built = 0
				sc_cities[k].buildings = {"m", "1"}
				sc_cities[k].army = {[1] = {sc_cities[k].country, 1, 16}, [2] = {sc_cities[k].country, 2, 6}}
				if sc_cities[k].country == "franceball" then
					local owner = sc_cities[k].owner
					colors[owner] = nil
					colors[owner] = {1,1,1}
				end
			end
			local function doai() aiTurn() end 
			timer.performWithDelay( 100, doai)
			displayScenarioAlt()
		end
	end
end
function displayScenarioAlt()
	local t = displayNewText("", 0, 0, "Arial", 16)
	wait = 1
	inside = 0
	t.phase = "ended"
	transition.to( t, { time=1, onComplete=displayScenario } )
end
function displayScenarioAlt1()
	battle = nil
	local t = displayNewText("", 0, 0, "Arial", 16)
	wait = 1
	inside = 0
	t.phase = "ended"
	transition.to( t, { time=1, onComplete=displayScenario } )
	transition.to( t, { time=2, onComplete=aiTurn } )
end
function moveCamera( event )
	if event.phase == "ended" and sc_map[event.target.xx][event.target.yy][3] ~= 1 and dontMoveCamera == 0 then
		local hi = 0
		for h = 1, #sc_heroes do
			if sc_heroes[h].pos.x == event.target.xx and sc_heroes[h].pos.y == event.target.yy then
				hi = 1
			end
		end
		if hi ~= 1 then
			sc_local[1][1] = event.target.xx
			sc_local[1][2] = event.target.yy
			displayScenarioAlt()
		end
	end
end
function displayScenarioMap()
	dontMoveCamera = 0
	if sc_local[1][1] < 5 then
		sc_local[1][1] = 5
	elseif sc_local[1][1] >= #sc_map-4 then
		sc_local[1][1] = #sc_map-4
	end
	if sc_local[1][2] < 5 then
		sc_local[1][2] = 5
	elseif sc_local[1][2] >= #sc_map[1]-4 then
		sc_local[1][2] = #sc_map[1]-4
	end
	wait = 0
	for x = 1, 9 do
		for y = 1, 9 do
			--for v = 1, 3 do
			local v = 1
				if sc_map[sc_local[1][1]-5+x] ~= nil then
					if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] > 0 then
						-- ground, environment
						local file = "img/map/"..me_c2[v].."/"..sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v]..".png"
						if me_c2[v] == "ground" then
							file = "img/map/ground.png"
						end
						local a = displayNewImage(file, 180+x*32, y*32-16, 4)
						if me_c2[v] == "ground" then
							local i = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v]
							a:setFillColor(grounds[i][1]/255, grounds[i][2]/255, grounds[i][3]/255)
						end
						a.xx = sc_local[1][1]-5+x
						a.yy = sc_local[1][2]-5+y
						a:addEventListener("touch", moveCamera)
					end
				end
			--end
		end
	end
	-- borders
	for x = 0, 10 do
		for y = 0, 10 do
			if sc_map[sc_local[1][1]-5+x] ~= nil and sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y] ~= nil and sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][1] > 0 then
				local map = {
					[-1] = 	{[-1] = 0, [0] = 0, [1] = 0},
					[0] = 	{[-1] = 0, [0] = 0, [1] = 0},
					[1] = 	{[-1] = 0, [0] = 0, [1] = 0},
					}
				local mapB = {
					[-1] = 	{[-1] = "", [0] = "", [1] = ""},
					[0] = 	{[-1] = "", [0] = "", [1] = ""},
					[1] = 	{[-1] = "", [0] = "", [1] = ""},
					}
				local xx, yy = sc_local[1][1]-5+x, sc_local[1][2]-5+y
				local id = sc_map[xx][yy][1]
				for x1 = -1, 1 do
					for y1 = -1, 1 do
						if xx+x1 > 0 and yy+y1 > 0 then
							if sc_map[xx+x1] ~= nil and sc_map[xx] and sc_map[xx+x1][yy+y1] ~= nil and sc_map[xx][yy] ~= nil then
								if sc_map[xx+x1][yy+y1][1] ~= sc_map[xx][yy][1] then
									map[x1][y1] = sc_map[xx+x1][yy+y1][1]
								end
							end
						end
					end
				end
				if map[-1][0] > id then -- ^^^
					if map[-1][-1] == 0 and map[-1][1] == 0 then
						mapB[-1][0] = "i3"
					elseif map[-1][-1] == 0 then
						mapB[-1][0] = "i"
					elseif map[-1][1] == 0 then
						mapB[-1][0] = "i2"
					else
						mapB[-1][0] = "b"
					end
				end
				if map[0][1] > id then -- >>>
					if map[1][1] == 0 and map[-1][1] == 0 then
						mapB[0][1] = "i3"
					elseif map[-1][1] == 0 then
						mapB[0][1] = "i"
					elseif map[1][1] == 0 then
						mapB[0][1] = "i2"
					else
						mapB[0][1] = "b"
					end
				end
				if map[1][0] > id then -- vvv
					if map[1][1] == 0 and map[1][-1] == 0 then
						mapB[1][0] = "i3"
					elseif map[1][1]  == 0 then
						mapB[1][0] = "i"
					elseif map[1][-1] == 0 then
						mapB[1][0] = "i2"
					else
						mapB[1][0] = "b"
					end
				end
				if map[0][-1] > id then -- <<<
					if map[-1][-1] == 0 and map[1][-1] == 0 then
						mapB[0][-1] = "i3"
					elseif map[1][-1] == 0 then
						mapB[0][-1] = "i"
					elseif map[-1][-1] == 0 then
						mapB[0][-1] = "i2"
					else
						mapB[0][-1] = "b"
					end
				end
				if mapB[-1][0] ~= "" and mapB[0][1] ~= "" then mapB[-1][1] = "c" end
				if mapB[0][1] ~= "" and mapB[1][0] ~= "" then mapB[1][1] = "c" end
				if mapB[1][0] ~= "" and mapB[0][-1] ~= "" then mapB[1][-1] = "c" end
				if mapB[-1][0] ~= "" and mapB[0][-1] ~= "" then mapB[-1][-1] = "c" end
				for x1 = -1, 1 do
					for y1 = -1, 1 do
						local typ = mapB[x1][y1]
						local angle = 0
						if (x1 == 1 and y1 == 0) or (x1 == 1 and y1 == 1) then
							angle = 90
						elseif (x1 == 0 and y1 == 1) or (x1 == -1 and y1 == 1) then
							angle = 180
						elseif (x1 == -1 and y1 == 0) or (x1 == -1 and y1 == -1) then
							angle = 270
						end
						if typ ~= "" and (y*32)-16+(y1*32) < 9*32 and 180+(x*32)+(x1*32) < 480 then
							local a = displayNewImage("img/map/ground_"..typ..".png", 180+(x*32)+(x1*32), (y*32)-16+(y1*32), 4)
							a:setFillColor(grounds[id][1]/255, grounds[id][2]/255, grounds[id][3]/255)
							a.rotation = angle
						end
					end
				end
			end
		end
	end
	for x = 1, 9 do
		for y = 1, 9 do
			for v = 2, 3 do
				if sc_map[sc_local[1][1]-5+x] ~= nil then
					if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] > 0 then
						local file
						if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][3] ~= 843 then
							file = "img/map/"..me_c2[v].."/"..sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v]..".png"
						else
							local i = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][4]
							file = "img/countries/"..i.country.."/"..i.tier..".png"
						end
						local a = displayNewImage(file, 180+x*32, y*32-16, 4)
						a.xx = sc_local[1][1]-5+x
						a.yy = sc_local[1][2]-5+y
						a:addEventListener("touch", moveCamera)
						-- building coloring
						if v == 3 then
							if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] == 1 then
								a:addEventListener("touch", castleTouch)
								a.castleid = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][4]
								local ow = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][6] or 0
								a:setFillColor(colors[ow][1], colors[ow][2], colors[ow][3])
							end
							if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] == 3 then
								local f = displayNewImage("img/flag.png", 180+x*32, y*32-16, 5)
								if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][5] == nil then
									sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][5] = 0
								end
								local ow = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][5] or 0
								f:setFillColor(colors[ow][1], colors[ow][2], colors[ow][3])
							end
							if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][3] == 4 then
								local ow = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][6] or 0
								a:setFillColor(colors[ow][1], colors[ow][2], colors[ow][3])
							end
							if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] == 10 then
								local t, i = sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][4], sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][6]
								if t == 1 then
									a.x = 9000
									a = displayNewImage("img/items/"..i..".png", 180+x*32, y*32-16, 4)
								elseif t == 2 then
									a:setFillColor(i_c_colors[i][1]/255, i_c_colors[i][2]/255, i_c_colors[i][3]/255)
								end
							end
							if sc_map[sc_local[1][1]-5+x][sc_local[1][2]-5+y][v] == 843 then
								a.y = a.y-((a.contentHeight-32)/2)
							end
						end
					end
				end
			end
		end
	end
	-- heroes
	local hh = 0
	local hmap = {}
	for h = 1, #sc_heroes do
		if sc_heroes[h].pos.x-sc_local[1][1] < 5 and sc_heroes[h].pos.x-sc_local[1][1] > -5 and sc_heroes[h].pos.y-sc_local[1][2] < 5 and sc_heroes[h].pos.y-sc_local[1][2] > -5 then
			local x, y = sc_heroes[h].pos.x-sc_local[1][1], sc_heroes[h].pos.y-sc_local[1][2]
			local fl = displayNewImage("img/flag.png", 180+(x+5)*32, (y+5)*32-29, 5)
			fl:setFillColor(colors[sc_heroes[h].owner][1], colors[sc_heroes[h].owner][2], colors[sc_heroes[h].owner][3])
			local obj = displayNewImage("img/countries/"..heroes[sc_heroes[h].hid].country.."/1.png", 180+(x+5)*32, (y+5)*32-16, 5)
			for i = 1, #heroes[sc_heroes[h].hid].attr do
				displayNewImage("img/attributes/"..heroes[sc_heroes[h].hid].attr[i]..".png", 180+(x+5)*32, (y+5)*32-16, 5)
			end
			if (sc_heroes[h].pos.x == sc_local[3][1] and sc_heroes[h].pos.y == sc_local[3][2]) then
				for h2 = 1, #sc_heroes do
					if sc_heroes[h2].id ~= sc_heroes[h].id then
						if hmap[sc_heroes[h2].pos.x] == nil then
							hmap[sc_heroes[h2].pos.x] = {}
						end
						hmap[sc_heroes[h2].pos.x][sc_heroes[h2].pos.y] = sc_heroes[h2].owner
					end
				end
				obj.alpha = 0.6
				hh = h
			end
			obj.hid = sc_heroes[h].id
			obj:addEventListener("touch", scHeroTouch)
		end
	end
	if hh ~= 0 then
		local allies = {}
		for k, v in pairs (sc_all) do
			if v[1] == sc_local[2] then
				table.insert(allies, v[2])
			elseif v[2] == sc_local[2] then
				table.insert(allies, v[1])
			end
		end
		local h = hh
		local x, y = sc_heroes[h].pos.x-sc_local[1][1], sc_heroes[h].pos.y-sc_local[1][2]
		local xx, yy = sc_heroes[h].pos.x, sc_heroes[h].pos.y
		if sc_heroes[h].stamina > 0 then
			if xx-1 > 0 and sc_map[xx-1][yy][2] == 0 then -- <<<
				local a = displayNewImage("img/arrow.png", 180+(x+5)*32-32, (y+5)*32-16, 5)
				a:addEventListener("touch", heroMove)
				a:scale(0.7, 0.7)
				a.alpha = 0.7
				a.px = -1
				a.py = 0
				local inpvp = 1
				for x1 = -2, 2 do
					for y1 = -2, 2 do
						if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1] ~= nil and sc_map[xx+x1][yy+y1][3] == 9 then
							inpvp = 0
						end
					end
				end
				if hmap[xx-1] ~= nil and hmap[xx-1][yy] ~= nil then
					local einpvp = 1
					for x1 = -2, 2 do
						for y1 = -2, 2 do
							if sc_map[xx+x1-1] ~= nil and sc_map[xx+x1-1][yy+y1] ~= nil and sc_map[xx+x1-1][yy+y1][3] == 9 then
								einpvp = 0
							end
						end
					end
					if hmap[xx-1] ~= nil and hmap[xx-1][yy] ~= sc_local[2] and isInArray(hmap[xx-1][yy], allies) == false and inpvp == 1 and einpvp == 1 then
						a:setFillColor(1, 0, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx-1][yy][3] == 1 then
					if sc_map[xx-1][yy][6] ~= sc_local[2] and isInArray(sc_map[xx-1][yy][6], allies) == false and inpvp == 1 then
						a:setFillColor(0, 0, 0)
					elseif sc_map[xx-1][yy][6] == sc_local[2] then
						a:setFillColor(0, 1, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx-1][yy][3] == 10 then
					a:setFillColor(97/255, 183/255, 183/255)
				elseif sc_map[xx-1][yy][3] == 843 then
					a:setFillColor(100/255, 0/255, 0/255)
				end
			end
			if xx+1 < #sc_map+1 and sc_map[xx+1][yy][2] == 0 then -- >>>
				local a = displayNewImage("img/arrow.png", 180+(x+5)*32+32, (y+5)*32-16, 5)
				a.rotation = 180
				a:addEventListener("touch", heroMove)
				a:scale(0.7, 0.7)
				a.alpha = 0.7
				a.px = 1
				a.py = 0
				local inpvp = 1
				for x1 = -2, 2 do
					for y1 = -2, 2 do
						if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1] ~= nil and sc_map[xx+x1][yy+y1][3] == 9 then
							inpvp = 0
						end
					end
				end
				if hmap[xx+1] ~= nil and hmap[xx+1][yy] ~= nil then
					local einpvp = 1
					for x1 = -2, 2 do
						for y1 = -2, 2 do
							if sc_map[xx+x1+1] ~= nil and sc_map[xx+x1+1][yy+y1] ~= nil and sc_map[xx+x1+1][yy+y1][3] == 9 then
								einpvp = 0
							end
						end
					end
					if hmap[xx+1][yy] ~= sc_local[2] and isInArray(hmap[xx+1][yy], allies) == false and inpvp == 1 and einpvp == 1 then
						a:setFillColor(1, 0, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx+1][yy][3] == 1 then
					if sc_map[xx+1][yy][6] ~= sc_local[2] and isInArray(sc_map[xx+1][yy][6], allies) == false and inpvp == 1 then
						a:setFillColor(0, 0, 0)
					elseif sc_map[xx+1][yy][6] == sc_local[2] then
						a:setFillColor(0, 1, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx+1][yy][3] == 10 then
					a:setFillColor(97/255, 183/255, 183/255)
				elseif sc_map[xx+1][yy][3] == 843 then
					a:setFillColor(100/255, 0/255, 0/255)
				end
			end
			if yy-1 > 0 and sc_map[xx][yy-1][2] == 0 then -- ^^^
				local a = displayNewImage("img/arrow.png", 180+(x+5)*32, (y+5)*32-16-32, 5)
				a.rotation = 90
				a:addEventListener("touch", heroMove)
				a:scale(0.7, 0.7)
				a.alpha = 0.7
				a.px = 0
				a.py = -1
				local inpvp = 1
				for x1 = -2, 2 do
					for y1 = -2, 2 do
						if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1] ~= nil and sc_map[xx+x1][yy+y1][3] == 9 then
							inpvp = 0
						end
					end
				end
				if hmap[xx] ~= nil and hmap[xx][yy-1] ~= nil then
					local einpvp = 1
					for x1 = -2, 2 do
						for y1 = -2, 2 do
							if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1-1] ~= nil and sc_map[xx+x1][yy+y1-1][3] == 9 then
								einpvp = 0
							end
						end
					end
					if hmap[xx][yy-1] ~= sc_local[2] and isInArray(hmap[xx][yy-1], allies) == false and inpvp == 1 and einpvp == 1 then
						a:setFillColor(1, 0, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx][yy-1][3] == 1 then
					if sc_map[xx][yy-1][6] ~= sc_local[2] and isInArray(sc_map[xx][yy-1][6], allies) == false and inpvp == 1 then
						a:setFillColor(0, 0, 0)
					elseif sc_map[xx][yy-1][6] == sc_local[2] then
						a:setFillColor(0, 1, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx][yy-1][3] == 10 then
					a:setFillColor(97/255, 183/255, 183/255)
				elseif sc_map[xx][yy-1][3] == 843 then
					a:setFillColor(100/255, 0/255, 0/255)
				end
			end
			if yy+1 < #sc_map[1]+1 and sc_map[xx][yy+1][2] == 0 then -- vvv
				local a = displayNewImage("img/arrow.png", 180+(x+5)*32, (y+5)*32-16+32, 5)
				a.rotation = 270
				a:addEventListener("touch", heroMove)
				a:scale(0.7, 0.7)
				a.alpha = 0.7
				a.px = 0
				a.py = 1
				local inpvp = 1
				for x1 = -2, 2 do
					for y1 = -2, 2 do
						if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1] ~= nil and sc_map[xx+x1][yy+y1][3] == 9 then
							inpvp = 0
						end
					end
				end
				if hmap[xx] ~= nil and hmap[xx][yy+1] ~= nil then
					local einpvp = 1
					for x1 = -2, 2 do
						for y1 = -2, 2 do
							if sc_map[xx+x1] ~= nil and sc_map[xx+x1][yy+y1+1] ~= nil and sc_map[xx+x1][yy+y1+1][3] == 9 then
								einpvp = 0
							end
						end
					end
					if hmap[xx][yy+1] ~= sc_local[2] and isInArray(hmap[xx][yy+1], allies) == false and inpvp == 1 and einpvp == 1 then
						a:setFillColor(1, 0, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx][yy+1][3] == 1 then
					if sc_map[xx][yy+1][6] ~= sc_local[2] and isInArray(sc_map[xx][yy+1][6], allies) == false and inpvp == 1 then
						a:setFillColor(0, 0, 0)
					elseif sc_map[xx][yy+1][6] == sc_local[2] then
						a:setFillColor(0, 1, 0)
					else
						a.x = -500
						a.y = -500
					end
				elseif sc_map[xx][yy+1][3] == 10 then
					a:setFillColor(97/255, 183/255, 183/255)
				elseif sc_map[xx][yy+1][3] == 843 then
					a:setFillColor(100/255, 0/255, 0/255)
				end
			end
		end
	end
end
displBl = 0
moveD = 0
function heroMove( event )
	if event.phase == "ended" then
		for h = 1, #sc_heroes do
			local ehid = 0
			for h1 = 1, #sc_heroes do
				if sc_heroes[h].id ~= sc_heroes[h1].id and sc_heroes[h].owner == sc_local[2] then
					if sc_heroes[h].pos.x+event.target.px == sc_heroes[h1].pos.x and sc_heroes[h].pos.y+event.target.py == sc_heroes[h1].pos.y then
						ehid = sc_heroes[h1].id
					end
				end
			end
			if ehid == 0 and sc_heroes[h].owner == sc_local[2] then
				
				if sc_local[3][1] ~= 0 and sc_local[3][2] ~= 0 and sc_map[sc_local[3][1]+event.target.px][sc_local[3][2]+event.target.py][3] == 1 and sc_map[sc_local[3][1]+event.target.px][sc_local[3][2]+event.target.py][6] ~= sc_local[2] then
					cleanImg()
					gui(480, 320, 240, 160, "Siege", 1)
					newButton( 240, 60, "Control city", 16, "Arial", doControlCity, {event.target.px, event.target.py})
					newButton( 240, 110, "Attack city", 16, "Arial", doAttackCity, {event.target.px, event.target.py})
				else
					if sc_heroes[h].pos.x == sc_local[3][1] and sc_heroes[h].pos.y == sc_local[3][2] then
						moveD = 1
						if sc_heroes[h].stamina > 0 then
							sc_heroes[h].pos.x = sc_heroes[h].pos.x+event.target.px
							sc_heroes[h].pos.y = sc_heroes[h].pos.y+event.target.py
							sc_heroes[h].stamina = sc_heroes[h].stamina-1
						end
					end
					if resources[sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3]] ~= nil then
						sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][5] = sc_local[2]
					end
					if sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3] == 4 then -- Capture Tower
						sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][6] = sc_local[2]
					end
					if sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3] == 6 then -- Spell Tower
						doSpellTower(h)
						return true
					end
					if sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3] == 10 then -- Babel Tower
						doTakeItem(h)
					end
					if sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3] == 843 then -- AI
						displBl = 1
						doAIBattle(h)
					end
					if displBl == 0 and moveD == 1 and isInArray(sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][3], {843}) == false then
						moveD = 0
						displayScenarioAlt()
						sc_local[3] = {0,0}
					end
				end
			else
				if sc_heroes[h].pos.x == sc_local[3][1] and sc_heroes[h].pos.y == sc_local[3][2] then
					displBl = 1
					local map = grounds[sc_map[sc_heroes[ehid].pos.x][sc_heroes[ehid].pos.y][1]][4]
					prepareBattle2(sc_heroes[h].id, ehid, map, 0, 0, 0)
				end
			end
		end
	end
end
function doAIBattle(h)
	local x, y = sc_heroes[h].pos.x, sc_heroes[h].pos.y
	local eInfo = sc_map[x][y][4]
	prepareBattle2(sc_heroes[h].id, 0, "desert", 0, 0, eInfo)
end
local hst = 0
function doTakeItem(h)
	local x, y = sc_heroes[h].pos.x, sc_heroes[h].pos.y
	local t, i = sc_map[x][y][4], sc_map[x][y][6]
	if t == 1 then
		table.insert(sc_heroes[h].pocket, i)
	elseif t == 2 then
		local temp = {}
		for i = 1, #items do
			if items[i].class == i then
				table.insert(temp, i)
			end
		end
		local rng = temp[math.random(1, #temp)]
		table.insert(sc_heroes[h].pocket, rng)
	end
	sc_map[x][y][3] = 0
	sc_map[x][y][4] = nil
	sc_map[x][y][6] = nil

	displayScenario()
end
function doSpellTower(h)
	cleanImg()
	displayScenario()
	dontMoveCamera = 1
	if h ~= nil then 
		hst = h
	else
		h = hst
	end
	gui( 288, 288, 340, 144, "Spell Tower", 1 )
	newButton( display.contentCenterX+40, display.contentCenterY+100, "Exit", 20, "Arial", displayScenarioAlt, {}, 128)
	local ty = sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][4]
	local temp = {}
	if ty == 3 and sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][6] == 0 then
		for i = 1, #spells do
			table.insert(temp, i)
		end
	elseif ty == 3 then
		local arr = {}
		for i = 1, #spells do
			if spells[i][9] == 3 then
				table.insert(arr, i)
			end
		end
		temp[1] = arr[sc_map[sc_heroes[h].pos.x][sc_heroes[h].pos.y][6]]
	elseif ty == 1 then
		for i = 1, #spells do
			if spells[i][9] == 1 then
				table.insert(temp, i)
			end
		end
	elseif ty == 2 then
		for i = 1, #spells do
			if spells[i][9] == 2 then
				table.insert(temp, i)
			end
		end
	end
	for y = 1, 2 do
		for x = 1, 4 do
			local n = x+((y-1)*4)+(arrows[48]*8)
			local xx, yy = (64*(x-2.5)+340), 64*y
			gui( 40, 40, xx, yy, "", 1 )
			if temp[n] ~= nil then
				local s = displayNewImage("img/spells/"..temp[n]..".png", xx, yy, 1)
				s.spellid = temp[n]
				s:addEventListener("touch", spellTowerTouch)
			end
		end
	end
	gui( 288, 70, 340, 192, "", 1 )
	displayArrows(display.contentCenterX+40, display.contentCenterY+100, 2, doSpellTower, 48, math.ceil(#temp/8)-1, {1, 1, 0})
end
function spellTowerTouch( event )
	if event.phase == "moved" then
		cleanImg(17)
		local obj = event.target
		local sid = obj.spellid
		displayNewText( spells[sid][1].."\n"..spells[sid][3].."\nMana: "..spells[sid][8].." Turns: "..spells[sid][7].." Cost: "..spells[sid][8]*4 .." gold", 340, 192, "Arial", 10, 17, "center" )
	elseif event.phase == "ended" then
		local obj = event.target
		local sid = obj.spellid
		if sc_players[sc_local[2]].money >= spells[sid][8]*4 and isInArray(sid, sc_heroes[hst].spells) == false then
			sc_players[sc_local[2]].money = sc_players[sc_local[2]].money-spells[sid][8]*4
			table.insert(sc_heroes[hst].spells, sid)
		end
		doSpellTower(hst)
		--displayScenarioAlt()
	else
		cleanImg(17)
	end
end
function doAttackCity(px, py)
	local a, cityid = 0, sc_map[sc_local[3][1]+px][sc_local[3][2]+py][4]
	for i = 1, #sc_cities do
		if sc_cities[i].cityid == cityid then
			if sc_cities[i].army ~= nil and #sc_cities[i].army > 0 then
				a = 1
			end
		end
	end
	if a ~= 0 then
		for i = 1, #sc_cities	do
			if sc_cities[i].cityid == sc_map[sc_local[3][1]+px][sc_local[3][2]+py][4] then
				for h = 1, #sc_heroes do
					if sc_heroes[h].pos.x == sc_local[3][1] and sc_heroes[h].pos.y == sc_local[3][2] then
						prepareBattle2( h, 0, "desert", 0, sc_cities[i].cityid, 0)
					end
				end
			end
		end
	else
		for i = 1, #sc_cities	do
			if sc_cities[i].cityid == sc_map[sc_local[3][1]+px][sc_local[3][2]+py][4] then
				sc_cities[i].owner = sc_local[2]
				sc_map[sc_local[3][1]+px][sc_local[3][2]+py][6] = sc_local[2]
				displayScenarioAlt()
			end
		end
	end
end
function doControlCity(px, py)
	for h = 1, #sc_heroes do
		if sc_heroes[h].pos.x == sc_local[3][1] and sc_heroes[h].pos.y == sc_local[3][2] then
			if sc_heroes[h].stamina > 0 then
				sc_heroes[h].pos.x = sc_heroes[h].pos.x+px
				sc_heroes[h].pos.y = sc_heroes[h].pos.y+py
				sc_heroes[h].stamina = sc_heroes[h].stamina-1
				displayScenarioAlt()
			end
		end
	end
end
local st = 0
function scHeroTouch( event )
	if event.phase == "began" then
		st = system.getTimer()
	elseif event.phase == "ended" then
		for h = 1, #sc_heroes do
			if sc_heroes[h].id == event.target.hid and sc_heroes[h].owner == sc_local[2] then
				if st+500 <= system.getTimer() then
					heroInfo( h )
				else
					if not(sc_local[3][1] == sc_heroes[h].pos.x and sc_local[3][2] == sc_heroes[h].pos.y) then
						sc_local[3][1], sc_local[3][2] = sc_heroes[h].pos.x, sc_heroes[h].pos.y
					else
						sc_local[3] = {0, 0}
					end
					displayScenario()
				end
			end
		end
	end
end
local jdsajd, jdsajd2 = 0, 0
function heroInfo( hid )
	cleanImg()
	displayScenario()
	if hid == nil then
		hid = jdsajd
		jdsajd2 = 0
	end
	jdsajd = hid
	dontMoveCamera = 1
	gui( 288, 288, 340, 144, "Hero Info", 1 )
	newButton( display.contentCenterX+40, display.contentCenterY+100, "Exit", 20, "Arial", displayScenarioAlt, {}, 128)
	local hi = heroes[sc_heroes[hid].hid]
	displayNewImage( "img/countries/"..hi.country.."/1.png", 250, 70 )
	if #hi.attr > 0 then
		for a = 1, #hi.attr do
			displayNewImage( "img/attributes/"..hi.attr[a]..".png", 250, 70 )
		end
	end
	displayNewText("Attack: ".. hi.att+((hi.att*sc_heroes[hid].level)*0.1).."\nDefense: ".. hi.def+((hi.def*sc_heroes[hid].level)*0.1).."\nInteligence: ".. hi.int*sc_heroes[hid].level.."\nMax mana: "..hi.int*sc_heroes[hid].level*5, 270, 140, "Arial", 14)
	displayNewText("Level: ".. sc_heroes[hid].level.."\nExperience: "..sc_heroes[hid].xp.."/"..(sc_heroes[hid].level < #levels and levels[sc_heroes[hid].level+1]) or levels[#levels], 400, 50, "Arial", 14)
	-- itanz -- 
	local it, po = sc_heroes[hid].items, sc_heroes[hid].pocket
	local temp = {["back"] = 0, ["hat"] = 0, ["left"] = 0, ["right"] = 0}
	if #it > 0 then
		for i = 1, #it do
			if temp[items[it[i]].slot] == 0 then
				temp[items[it[i]].slot] = it[i]
			end
		end
	end
	gui( 64, 64, 365, 100, "", 1 )
	displayNewText("BACK", 365, 100, 1).alpha = 0.5
	if temp["back"] ~= 0 then
		local ix = displayNewImage( "img/items/"..temp["back"]..".png", 365, 100 )
		ix:scale(0.75, 0.75)
		ix.slot = "back"
		ix.hid = hid
		ix:addEventListener("touch", itemTouch)
	end
	gui( 64, 64, 435, 100, "", 1 )
	displayNewText("HAT", 435, 100, 1).alpha = 0.5
	if temp["hat"] ~= 0 then
		local ix = displayNewImage( "img/items/"..temp["hat"]..".png", 435, 100 )
		ix:scale(0.75, 0.75)
		ix.slot = "hat"
		ix.hid = hid
		ix:addEventListener("touch", itemTouch)
	end
	gui( 64, 64, 365, 160, "", 1 )
	displayNewText("RIGHT", 365, 160, 1).alpha = 0.5
	if temp["left"] ~= 0 then
		local ix = displayNewImage( "img/items/"..temp["left"]..".png", 365, 160 )
		ix:scale(0.75, 0.75)
		ix.slot = "left"
		ix.hid = hid
		ix:addEventListener("touch", itemTouch)
	end
	gui( 64, 64, 435, 160, "", 1 )
	displayNewText("LEFT", 435, 160, 1).alpha = 0.5
	if temp["right"] ~= 0 then
		local ix = displayNewImage( "img/items/"..temp["right"]..".png", 435, 160 )
		ix:scale(0.75, 0.75)
		ix.slot = "right"
		ix.hid = hid
		ix:addEventListener("touch", itemTouch)
	end
	-- pocket -- 
	for i = 1, 4 do
		local g = 0
		if i == jdsajd2 then
			g = gui( 48, 48, 260+((i-1)*52), 217, "", 2 )
			if #sc_heroes[hid].items > 0 then
				for i = 1, #sc_heroes[hid].items do
					if items[sc_heroes[hid].items[i]].slot == items[po[i+arrows[51]]].slot then
						switchDisplay( hid, items[sc_heroes[hid].items[i]].slot )
					end
				end
			end
		else
			g = gui( 48, 48, 260+((i-1)*52), 217, "", 1 )
		end
		g.number = i
		g.hid = hid
		if #po+arrows[51] >= i then
			local ix = displayNewImage( "img/items/"..po[i+arrows[51]]..".png", 260+((i-1)*52), 217 )
			ix:scale(0.5, 0.5)
			g:addEventListener("touch", pocketTouch)
		end
	end
	displayArrows(260+((2.5-1)*52), 220, 3.2, heroInfo, 51, #po-4, {1, 1, 0})
end
function switchDisplay( hid, slot )
	gui( 288, 190, 340, 95, "", 1 )
	---268, 412
	local po = sc_heroes[hid].pocket
	local i1, i2 = 0, 0
	i1 = po[arrows[51]+jdsajd2]
	for i = 1, #sc_heroes[hid].items do
		if items[sc_heroes[hid].items[i]].slot == slot then
			i2 = sc_heroes[hid].items[i]
		end
	end
	displayNewText(items[i1][1], 268, 32, "Arial", 16, 1, "center"):setFillColor(i_c_colors[items[i1].class][1]/255, i_c_colors[items[i1].class][2]/255, i_c_colors[items[i1].class][3]/255)
	displayNewText(items[i2][1], 412, 32, "Arial", 16, 1, "center"):setFillColor(i_c_colors[items[i2].class][1]/255, i_c_colors[items[i2].class][2]/255, i_c_colors[items[i2].class][3]/255)
	local n = 0 
	for k, v in pairs (items[i1][2]) do
		n = n+1
		local a = displayNewText(items_att[k].." "..((v>0 and "+") or "-")..""..v, 268, 38+(n*14), "Arial", 12, 1, "center")
		local i2_v = 0
		for k1, v1 in pairs (items[i2][2]) do
			if k == k1 then
				i2_v = v1
			end
		end
		if v > i2_v then
			a:setFillColor(58/255, 128/255, 73/255)
		elseif i2_v > v then
			a:setFillColor(255/255, 86/255, 86/255)
		else
			a:setFillColor(255/255, 247/255, 125/255)
		end
	end
	n = 0
	for k, v in pairs (items[i2][2]) do
		n = n+1
		local a = displayNewText(items_att[k].." "..((v>0 and "+") or "-")..""..v, 412, 38+(n*14), "Arial", 12, 1, "center")
		local i1_v = 0
		for k1, v1 in pairs (items[i1][2]) do
			if k == k1 then
				i1_v = v1
			end
		end
		if v > i1_v then
			a:setFillColor(58/255, 128/255, 73/255)
		elseif i1_v > v then
			a:setFillColor(255/255, 86/255, 86/255)
		else
			a:setFillColor(255/255, 247/255, 125/255)
		end
	end
	newButton( 340, 160, "Switch", 16, "Arial", switchTouch, {slot, hid})
end
function switchTouch( slot, hid )
	local po = sc_heroes[hid].pocket
	local i1, i2 = 0, 0
	i1 = po[arrows[51]+jdsajd2]
	for i = 1, #sc_heroes[hid].items do
		if items[sc_heroes[hid].items[i]].slot == slot then
			i2 = sc_heroes[hid].items[i]
		end
	end
	for i = 1, #po do
		if po[i] == i1 then
			table.remove(po, i)
		end
	end
	for i = 1, #sc_heroes[hid].items do
		if sc_heroes[hid].items[i] == i2 then
			table.remove(sc_heroes[hid].items, i)
		end
	end
	table.insert(sc_heroes[hid].items, i1)
	table.insert(sc_heroes[hid].pocket, i2)
	jdsajd2 = 0
	heroInfo( hid )
end
function itemTouch( event )
	if event.phase == "ended" then
		local slot = event.target.slot
		local hid = event.target.hid
		for i = 1, #sc_heroes[hid].items do
			if items[sc_heroes[hid].items[i]].slot == slot then
				table.insert(sc_heroes[hid].pocket, sc_heroes[hid].items[i])
				table.remove(sc_heroes[hid].items, i)
			end
		end
		jdsajd2 = 0
		heroInfo(event.target.hid)
	end
end
function pocketTouch( event )
	if event.phase == "ended" then
		local slot, taken = items[sc_heroes[event.target.hid].pocket[event.target.number+arrows[51]]].slot, 0
		if #sc_heroes[event.target.hid].items > 0 then
			for i = 1, #sc_heroes[event.target.hid].items do
				if slot == items[sc_heroes[event.target.hid].items[i]].slot then
					taken = 1
				end
			end
		end
		if taken == 1 then
			if jdsajd2 == event.target.number then
				jdsajd2 = 0
			else
				jdsajd2 = event.target.number
			end
		else
			table.insert(sc_heroes[event.target.hid].items, sc_heroes[event.target.hid].pocket[event.target.number+arrows[51]])
			table.remove(sc_heroes[event.target.hid].pocket, event.target.number+arrows[51])
		end
		heroInfo(event.target.hid)
	end
end
djf = 0
function alliancesMenu(event)
	if event.phase == "ended" then
		displayScenario()
		dontMoveCamera = 1
		gui( 208, 288, 300, 144, "Alliances", 1 )
		gui( 80, 288, 444, 144, "Offers", 1 )
		local n = 0
		local m = 0
		for k, v in pairs (sc_all) do
			if v[1] == sc_local[2] or v[2] == sc_local[2] then
				m = m+1
				local g, r = v[4], v[5]
				if v[1] == sc_local[2] then
					g = g*-1
					r = r*-1
				end
				gui(180, 72, 300, 5+(75*m)-20, "", 1)
				local pid = v[1]
				if v[1] == sc_local[2] then pid = v[2] end
				local p = displayNewText( "Player "..pid, 300, -14+(75*m)-20, "Arial", 16)
				p:setFillColor(colors[(v[1] == sc_local[2] and v[2]) or v[1]][1], colors[(v[1] == sc_local[2] and v[2]) or v[1]][2], colors[(v[1] == sc_local[2] and v[2]) or v[1]][3])
				displayNewText("Expiration day:\nDay: "..v[3][1]..", Week: "..v[3][2]..", Month: "..v[3][3]..", Year: "..v[3][4], 300, 5+(75*m)-20, "Arial", 8)
				displayNewText("Daily: ", 230, 25+(75*m)-20, "Arial", 8)
				local go = displayNewText(g.."% of gold", 270, 25+(75*m)-20, "Arial", 8)
				if g > 0 then go:setFillColor(0,1,0) elseif g < 0 then go:setFillColor(1,0,0) end
				local re = displayNewText(r.."% of resources", 340, 25+(75*m)-20, "Arial", 8)
				if r > 0 then re:setFillColor(0,1,0) elseif r < 0 then re:setFillColor(1,0,0) end
			end
		end
		for k, v in pairs (sc_all_o) do
			if v[2] == sc_local[2] then
				n = n+1
				gui(70, 48, 444, 5+(60*n), "", 1)
				local p = displayNewText( "Player "..v[1], 444, -5+(60*n), "Arial", 16)
				p:setFillColor(colors[v[1]][1], colors[v[1]][2], colors[v[1]][3])
				local q = displayNewImage("img/q_mark.png", 426, 15+(60*n))
				q.keyy = k
				q:scale(0.7, 0.7)
				q:addEventListener("touch", allianceDetails)
				local e = displayNewImage("img/exit.png", 462, 15+(60*n))
				e.keyy = k
				e:scale(0.7, 0.7)
				e:addEventListener("touch", allianceCancel)
			end
		end
		newButton( 444, display.contentCenterY+110, "Make", 20, "Arial", allianceMake, {}, 64)
		newButton( display.contentCenterX+40, display.contentCenterY+110, "Exit", 20, "Arial", displayScenarioAlt, {}, 128)
		djf = 0
	end
end
function allianceDetails(event)
	if event.phase == "ended" then
		local off = sc_all_o[event.target.keyy]
		displayScenario()
		dontMoveCamera = 1
		gui( 288, 288, 340, 144, "Offer Details", 1 )
		local e = displayNewImage("img/exit.png", 230, 240)
		e.keyy = event.target.keyy
		e:addEventListener("touch", allianceCancel)
		local a = displayNewImage("img/accept.png", 442, 240)
		a.keyy = event.target.keyy
		a.off = off
		a:addEventListener("touch", allianceAccept)


		displayNewText( "Offer from:", 270, 50, "Arial", 16)
		local p = displayNewText( "Player "..off[1], 360, 50, "Arial", 14)
		p:setFillColor(colors[off[1]][1], colors[off[1]][2], colors[off[1]][3])

		displayNewText( "Offer:", 340, 80, "Arial", 16)
		local g = displayNewText( off[6].." gold", 268, 100, "Arial", 12)
		if off[6] < 0 then g:setFillColor(1,0,0) elseif off[6] > 0 then g:setFillColor(0,1,0) end
		local r = displayNewText( off[7] .." resources", 412, 100, "Arial", 12)
		if off[7] < 0 then r:setFillColor(1,0,0) elseif off[7] > 0 then r:setFillColor(0,1,0) end

		displayNewText( "Daily:", 340, 130, "Arial", 16)
		local g = displayNewText( off[4] .."% of gold", 268, 150, "Arial", 12)
		if off[4] < 0 then g:setFillColor(1,0,0) elseif off[4] > 0 then g:setFillColor(0,1,0) end
		local r = displayNewText( off[5] .."% of resources", 412, 150, "Arial", 12)
		if off[5] < 0 then r:setFillColor(1,0,0) elseif off[5] > 0 then r:setFillColor(0,1,0) end

		local d = displayNewText( "Expiration date:", 340, 180, "Arial", 16)
		displayNewText( "Day:", 254, 194, "Arial", 10)
		displayNewText( off[3][1], 254, 220, "Arial", 10)
		displayNewText( "Week:", 310, 194, "Arial", 10)
		displayNewText( off[3][2], 310, 220, "Arial", 10)
		displayNewText( "Month:", 366, 194, "Arial", 10)
		displayNewText( off[3][3], 366, 220, "Arial", 10)
		displayNewText( "Year:", 422, 194, "Arial", 10)
		displayNewText( off[3][4], 422, 220, "Arial", 10)
	end
end
function allianceCancel(event)
	if event.phase == "ended" then
		table.remove(sc_all_o,event.target.keyy)
		alliancesMenu({phase = "ended"})
	end
end
function allianceAccept(event)
	if event.phase == "ended" then
		local of = event.target.off
		local who1, who2 = of[1], of[2]
		local able = 1
		if ((of[6] > 0 and sc_players[who1].money <= math.abs(of[6])) or (of[6] < 0 and sc_players[who2].money <= math.abs(of[6]))) and of[6] == 0 then
			able = 0
		end
		if ((of[7] > 0 and sc_players[who1].minerals <= math.abs(of[7])) or (of[7] < 0 and sc_players[who2].minerals <= math.abs(of[7]))) and of[7] == 0 then
			able = 0
		end
		if able == 1 then
			local of2 = {of[1], of[2], of[3], of[4], of[5]}
			sc_players[who1].money = sc_players[who1].money-of[6]
			sc_players[who2].money = sc_players[who2].money+of[6]
			sc_players[who1].minerals = sc_players[who1].minerals-of[7]
			sc_players[who2].minerals = sc_players[who2].minerals+of[7]
			table.insert(sc_all, of2)
			table.remove(sc_all_o,event.target.keyy)
		end
		dontMoveCamera = 1
		displayScenario()
	end
end
function alliancePlayerChange()
	djf = 0
	allianceMake()
end
function allianceMake()
	displayScenario()
	dontMoveCamera = 1
	gui( 288, 288, 340, 144, "Offer Alliance", 1 )
	newButton( display.contentCenterX+40, display.contentCenterY+100, "Exit", 20, "Arial", displayScenarioAlt, {}, 128)
	local pl = {}
	local all = {}
	for k,v in pairs (sc_all) do
		if v[1] == sc_local[2] and isInArray(v[2], all) == false then
			table.insert(all, v[2])
		elseif v[2] == sc_local[2] and isInArray(v[1], all) == false then
			table.insert(all, v[1])
		end
	end
	for k,v in pairs (sc_all_o) do
		if v[1] == sc_local[2] and isInArray(v[2], all) == false then
			table.insert(all, v[2])
		elseif v[2] == sc_local[2] and isInArray(v[1], all) == false then
			table.insert(all, v[1])
		end
	end
	local d = 0
	for i = 1, #sc_players do
		if i ~= sc_local[2] and isInArray(i, all) == false then
			pl[i-d] = i
		else
			d = d+1
		end
	end
	if #pl == 0 then
		displayScenario()
		return true
	end
	if djf == 0 then
		arrows[37] = math.floor(sc_players[pl[arrows[36]+1]].money/100)
		arrows[38] = math.floor(sc_players[pl[arrows[36]+1]].minerals/10)
	end
	if arrows[36]+1 > #pl then
		arrows[36] = 0
	end
	displayNewText( "Offer to:", 250, 50, "Arial", 16)
	local p = displayNewText( "Player "..pl[arrows[36]+1], 340, 50, "Arial", 14)
	local pid = pl[arrows[36]+1]
	p:setFillColor(colors[pid][1], colors[pid][2], colors[pid][3])
	displayArrows(340, 50, 1.2, alliancePlayerChange, 36, #pl-1, {1, 1, 0})

	displayNewText( "Offer:", 340, 80, "Arial", 16)
	local go = (arrows[37]-math.floor(sc_players[pl[arrows[36]+1]].money/100))*100
	local g = displayNewText( go .." gold", 268, 100, "Arial", 12)
	if go > 0 then g:setFillColor(1,0,0) elseif go < 0 then g:setFillColor(0,1,0) end
	displayArrows(268, 100, 1.4, allianceMake, 37, math.floor(sc_players[pl[arrows[36]+1]].money/100)+math.floor(sc_players[sc_local[2]].money/100), {1, 1, 0})
	local re = (arrows[38]-math.floor(sc_players[pl[arrows[36]+1]].minerals/10))*10
	local r = displayNewText( (arrows[38]-math.floor(sc_players[pl[arrows[36]+1]].minerals/10))*10 .." resources", 412, 100, "Arial", 12)
	if re > 0 then r:setFillColor(1,0,0) elseif re < 0 then r:setFillColor(0,1,0) end
	displayArrows(412, 100, 1.4, allianceMake, 38, math.floor(sc_players[pl[arrows[36]+1]].minerals/10)+math.floor(sc_players[sc_local[2]].minerals/10), {1, 1, 0})

	displayNewText( "Daily:", 340, 130, "Arial", 16)
	local offer = {sc_local[2], pid, {arrows[40]+1, arrows[41]+1, arrows[42]+1, arrows[43]+1}, (arrows[39]-10)*10, (arrows[44]-10)*10, ((arrows[37]-math.floor(sc_players[pl[arrows[36]+1]].money/100))*100), ((arrows[38]-math.floor(sc_players[pl[arrows[36]+1]].minerals/10))*10)}

	local able1 = {g = 100, r = 100}
	local able2 = {g = 100, r = 100}
	for k,v in pairs (sc_all) do
		if v[1] == sc_local[2] then
			if v[4] > 0 then
				able1.g = able1.g-v[4]
			end
			if v[5] > 0 then
				able1.r = able1.r-v[5]
			end
		elseif v[2] == sc_local[2] then
			if v[4] < 0 then
				able1.g = able1.g+v[4]
			end
			if v[5] < 0 then
				able1.r = able1.r+v[5]
			end
		end
		if v[1] == pid then
			if v[4] > 0 then
				able2.g = able2.g-v[4]
			end
			if v[5] > 0 then
				able2.r = able2.r-v[5]
			end
		elseif v[2] == pid then
			if v[4] < 0 then
				able2.g = able2.g+v[4]
			end
			if v[5] < 0 then
				able2.r = able2.r+v[5]
			end
		end
	end
	for k,v in pairs (sc_all_o) do
		if v[1] == sc_local[2] then
			if v[4] > 0 then
				able1.g = able1.g-v[4]
			end
			if v[5] > 0 then
				able1.r = able1.r-v[5]
			end
		elseif v[2] == sc_local[2] then
			if v[4] < 0 then
				able1.g = able1.g+v[4]
			end
			if v[5] < 0 then
				able1.r = able1.r+v[5]
			end
		end
		if v[1] == pid then
			if v[4] > 0 then
				able2.g = able2.g-v[4]
			end
			if v[5] > 0 then
				able2.r = able2.r-v[5]
			end
		elseif v[2] == pid then
			if v[4] < 0 then
				able2.g = able2.g+v[4]
			end
			if v[5] < 0 then
				able2.r = able2.r+v[5]
			end
		end
	end
	able1 = {g = able1.g/10, r = able1.r/10}
	able2 = {g = able2.g/10, r = able2.r/10}
	if djf == 0 then
		arrows[39] = able2.g
		arrows[44] = able2.r
	end

	local g = displayNewText( (arrows[39]-able2.g)*10 .."% of gold", 268, 150, "Arial", 12)
	if (arrows[39]-able2.g)*10 > 0 then g:setFillColor(1,0,0) elseif (arrows[39]-able2.g)*10 < 0 then g:setFillColor(0,1,0) end
	displayArrows(268, 150, 1.4, allianceMake, 39, (able2.g+able1.g), {1, 1, 0})
	local r = displayNewText( (arrows[44]-able2.r)*10 .."% of resources", 412, 150, "Arial", 8)
	if (arrows[44]-able2.r)*10 > 0 then r:setFillColor(1,0,0) elseif (arrows[44]-able2.r)*10 < 0 then r:setFillColor(0,1,0) end
	displayArrows(412, 150, 1.4, allianceMake, 44, (able2.r+able1.r), {1, 1, 0})

	local d = displayNewText( "Expiration date:", 340, 180, "Arial", 16)
	local ti = sc_local[4]
	local days = ((((((ti[4]-1)*12)+(ti[3]-1))*4)+(ti[2]-1))*7)+ti[1]
	local edays = ((((((arrows[43])*12)+(arrows[42]))*4)+(arrows[41]))*7)+arrows[40]+1
	if days > edays or edays-days > 60 or edays-days < 7 then
		d:setFillColor(1,0,0)
	else
		newButton( display.contentCenterX+170, display.contentCenterY+100, "Send", 20, "Arial", allianceSend, {offer}, 128)
		d:setFillColor(0,1,0)
	end
	displayNewText( "Day:", 254, 194, "Arial", 10)
	displayNewText( arrows[40]+1, 254, 220, "Arial", 10)
	displayNewText( "Week:", 310, 194, "Arial", 10)
	displayNewText( arrows[41]+1, 310, 220, "Arial", 10)
	displayNewText( "Month:", 366, 194, "Arial", 10)
	displayNewText( arrows[42]+1, 366, 220, "Arial", 10)
	displayNewText( "Year:", 422, 194, "Arial", 10)
	displayNewText( arrows[43]+1, 422, 220, "Arial", 10)
	displayArrows(254, 220, 0.6, allianceMake, 40, 6, {1, 1, 0})
	displayArrows(310, 220, 0.6, allianceMake, 41, 3, {1, 1, 0})
	displayArrows(366, 220, 0.6, allianceMake, 42, 11, {1, 1, 0})
	displayArrows(422, 220, 0.6, allianceMake, 43, sc_local[4][4], {1, 1, 0})

	djf = 1
end
function allianceSend( offer )
	table.insert(sc_all_o, offer)
	displayScenarioAlt()
end
function debugInfo( event )
	if event.phase == "ended" then
		print(#sc_heroes)
		print(">>> >>> >>>")
		for k,v in pairs(sc_heroes) do
			print(">> ["..k.."]")
			for k1,v1 in pairs(v) do
				print(k1)
				print(v1)
				print(">>>")
			end
		end
	end
end
function displayScenario()
	if battle ~= nil then
		return false
	end
	cleanImg()
	gui(480, 320, 240, 160, "", 2)
	displayScenarioMap()
	gui(196, 320, 98, 160, "", 1)
	local t = displayNewImage( "img/turn.png", 30, 265 )
	t:addEventListener("touch", scTurn)
	local t = displayNewImage( "img/alliance.png", 70, 265 )
	t:addEventListener("touch", alliancesMenu)
	--local t = displayNewImage( "img/q_mark.png", 120, 265 )
	--t:addEventListener("touch", debugInfo)
	gui(288, 32, 340, 304, "", 1)
	displayNewText( "Your monies: "..sc_players[sc_local[2]].money.." | Your mineralz: "..sc_players[sc_local[2]].minerals, 340, 304, "Arial", 12)
	displayNewText( "Day "..sc_local[4][1]..", Week "..sc_local[4][2]..", Month "..sc_local[4][3]..", Year "..sc_local[4][4], 115, 304, "Arial", 10)
	gui(32, 32, 18, 18, "", 2)
	local f = displayNewImage( "img/flag.png", 10, 24 )
	f:scale(1.5, 1.5)
	f:setFillColor(colors[sc_local[2]][1], colors[sc_local[2]][2], colors[sc_local[2]][3])
	-- city list \/
	local carray = {}
	for i = 1, #sc_cities do
		if sc_cities[i].owner == sc_local[2] then
			table.insert(carray, sc_cities[i])
		end
	end
	local a = displayNewImage( "img/arrow.png", 22, 55)
	a.rotation = 90
	if sc_local[5] <= 1 then
		a.alpha = 0.5
	else
		a:addEventListener("touch", cUp)
	end
	local a = displayNewImage( "img/arrow.png", 22, 210)
	a.rotation = 270
	if #carray < sc_local[5]+2 then
		a.alpha = 0.5
	else
		a:addEventListener("touch", cDown)
	end
	for i = 0, 2 do
		gui(40, 40, 22, 90+(42*i), "", 2)
		if #carray >= i+sc_local[5] then
			local cc = displayNewImage( "img/map/building/1.png", 22, 90+(42*i) )
			cc.alpha = 0.6
			displayNewImage( "img/countries/"..carray[i+sc_local[5]].country.."/1.png", 22, 90+(42*i) ).alpha = 0.2
			for x = 1, #sc_map do
				for y = 1, #sc_map[x] do
					if sc_map[x][y][3] == 1 then
						if sc_map[x][y].cityid == carray[i+sc_local[5]].id and sc_map[x][y][6] == sc_local[2] then
							cc.xx = x
							cc.yy = y+1
							break
						end
					end
				end
			end
			cc:addEventListener("touch", ccTouch)
		end
	end
	-- hero list \/
	local harray = {}
	for i = 1, #sc_heroes do
		if sc_heroes[i].owner == sc_local[2] then
			table.insert(harray, i)
		end
	end
	local a = displayNewImage( "img/arrow.png", 66, 55)
	a.rotation = 90
	if sc_local[6] <= 1 then
		a.alpha = 0.5
	else
		a:addEventListener("touch", cUp2)
	end
	local a = displayNewImage( "img/arrow.png", 66, 210)
	a.rotation = 270
	if #harray < sc_local[6]+2 then
		a.alpha = 0.5
	else
		a:addEventListener("touch", cDown2)
	end
	for i = 0, 2 do
		gui(40, 40, 66, 90+(42*i), "", 2)
		if #harray >= i+sc_local[6] then
			local cc = displayNewImage( "img/countries/"..heroes[sc_heroes[harray[i+sc_local[6]]].hid].country.."/1.png", 66, 90+(42*i) )
			cc:scale(0.7, 0.7)
			local hi = heroes[sc_heroes[harray[i+sc_local[6]]].hid]
			if #hi.attr > 0 then
				for j = 1, #hi.attr do
					displayNewImage( "img/attributes/"..hi.attr[j]..".png", 66, 90+(42*i) ):scale(0.7, 0.7)
				end
			end
			cc.xx = sc_heroes[harray[i+sc_local[6]]].pos.x
			cc.yy = sc_heroes[harray[i+sc_local[6]]].pos.y
			cc:addEventListener("touch", ccTouch)
		end
	end
end
function ccTouch(event)
	if event.phase == "ended" then
		sc_local[1][1] = event.target.xx
		sc_local[1][2] = event.target.yy
		displayScenarioAlt()
	end
end
function cUp(event)
	if event.phase == "ended" then
		sc_local[5] = sc_local[5]-1
		displayScenario()
	end
end
function cDown(event)
	if event.phase == "ended" then
		sc_local[5] = sc_local[5]+1
		displayScenario()
	end
end
function cUp2(event)
	if event.phase == "ended" then
		sc_local[6] = sc_local[6]-1
		displayScenario()
	end
end
function cDown2(event)
	if event.phase == "ended" then
		sc_local[6] = sc_local[6]+1
		displayScenario()
	end
end
function scTurn(event)
	if event.phase == "ended" then
		if checkGameEnded() ~= true then
			sc_local[3] = {0,0}
			local o = sc_local[2]
			local a = 0
			while o == sc_local[2] do
				a = a + 1
				if sc_local[2]+a > #sc_players then
					a = -sc_local[2]+1
				end
				if sc_players[sc_local[2]+a].alive == 1 then
					sc_local[2] = sc_local[2]+a
				end
			end
			if o > sc_local[2] then
				for h = 1, #sc_heroes do
					sc_heroes[h].stamina = 5
				end
				for c = 1, #sc_cities do
					sc_cities[c].built = 0
				end
				-- \/ time \/ --
				sc_local[4][1] = sc_local[4][1]+1
				-- \/ mineralz \/ --
				for i = 1, #sc_resources do
					local res = resources[sc_map[sc_resources[i][1]][sc_resources[i][2]][3]].r
					local mon = resources[sc_map[sc_resources[i][1]][sc_resources[i][2]][3]].g
					local mine = sc_map[sc_resources[i][1]][sc_resources[i][2]]
					if res ~= nil and mon ~= nil and mine[3] ~= nil and mine[5] ~= 0 and sc_players[sc_map[sc_resources[i][1]][sc_resources[i][2]][5]] ~= nil then
						local ow = sc_map[sc_resources[i][1]][sc_resources[i][2]][5]
						local r2 = res
						local g2 = mon
						local gi = {}
						for k, v in pairs(sc_all) do
							if v[1] == ow then
								gi[#gi+1] = {v[2], math.floor((r2*v[5])/100), math.floor((g2*v[4])/100)}
								if v[4] > 0 then
									g2 = g2 - math.floor((g2*v[4])/100)
								end
								if v[5] > 0 then
									r2 = r2 - math.floor((r2*v[5])/100)
								end
							elseif v[2] == ow then
								gi[#gi+1] = {v[1], math.floor((r2*v[5])/100), math.floor((g2*v[4])/100)}
								if v[4] < 0 then
									g2 = g2 - math.floor((g2*v[4])/100)
								end
								if v[5] < 0 then
									r2 = r2 - math.floor((r2*v[5])/100)
								end
							end
						end
						if #gi > 0 then
							for i = 1, #gi do
								sc_players[gi[i][1]].minerals = sc_players[gi[i][1]].minerals+gi[i][2]
								sc_players[gi[i][1]].money = sc_players[gi[i][1]].money+gi[i][3]
							end
						end

						sc_players[sc_map[sc_resources[i][1]][sc_resources[i][2]][5]].minerals = sc_players[sc_map[sc_resources[i][1]][sc_resources[i][2]][5]].minerals + r2
						sc_players[sc_map[sc_resources[i][1]][sc_resources[i][2]][5]].money = sc_players[sc_map[sc_resources[i][1]][sc_resources[i][2]][5]].money + g2
					end
				end
				-- /\ mineralz /\ --
				-- \/ monies \/ --
				for i = 1, #sc_cities do
					local control = 0
					if sc_cities[i].owner ~= nil and sc_cities[i].owner ~= 0 then
						for x = 1, #sc_map do
							for y = 1, #sc_map[1] do
								if sc_map[x] ~= nil and sc_map[x][y] ~= nil and sc_map[x][y][3] == 1 and sc_map[x][y][4] == sc_cities[i].cityid then
									for h = 1, #sc_heroes do
										if sc_heroes[h].pos.x == x and sc_heroes[h].pos.y == y then
											control = sc_heroes[h].owner
										end
									end
								end
							end
						end
						if control == 0 then
							local g = 1000
							local gi = {}
							for k, v in pairs(sc_all) do
								if v[1] == sc_cities[i].owner and v[4] > 0 then
									gi[#gi+1] = {v[2], math.floor((g*v[4])/100)}
									g = g - math.floor((g*v[4])/100)
								elseif v[2] == sc_cities[i].owner and v[4] < 0 then
									gi[#gi+1] = {v[1], math.floor((g*v[4])/100)}
									g = g - math.floor((g*v[4])/100)
								end
							end
							if #gi > 0 then
								for i = 1, #gi do
									sc_players[gi[i][1]].money = sc_players[gi[i][1]].money+gi[i][2]
								end
							end
							sc_players[sc_cities[i].owner].money = sc_players[sc_cities[i].owner].money+g
						else
							sc_players[control].money = sc_players[control].money+1000
						end
					end
				end
				-- /\ monies /\ --
				if sc_local[4][1] == 8 then -- end of week
					for i = 1, #sc_cities do
						for j = 1, 5 do
							if isInArray(tostring(j), sc_cities[i].buildings) == true then
								sc_cities[i].buyable[j] = sc_cities[i].buyable[j]+grow[j]
							end
						end
					end
					sc_local[4][1] = 1
					sc_local[4][2] = sc_local[4][2]+1
					if sc_local[4][2] == 5 then	-- end of month
						sc_local[4][2] = 1
						sc_local[4][3] = sc_local[4][2]+1
						if sc_local[4][3] == 13 then -- end of year
							sc_local[4][3] = 1
							sc_local[4][4] = sc_local[4][4]+1
						end
					end
				end
				-- /\ time /\ --
				-- \/ alliance expirance \/ --
				for k,v in pairs(sc_all) do
					if v[3][1] == sc_local[4][1] and v[3][2] == sc_local[4][2] and v[3][3] == sc_local[4][3] and v[3][4] == sc_local[4][4] then
						table.remove(sc_all, k)
					end
				end
				-- /\ endz alliance expirance /\ --
			end
			sc_local[5] = 1
			aiTurn()
			displayScenario()
		end
	end
end
function castleTouch(event)
	if event.phase == "ended" then
		if (sc_local[3][1] == 0 and sc_local[3][2] == 0) or (sc_local[3][1] ~= event.target.xx or sc_local[3][2] ~= event.target.yy) then
			local id = sc_map[event.target.xx][event.target.yy][4]
			displayCastleSC(id)--event.target.castleid)
		end
	end
end
function displayCastleSC( id )
	local ctype = 0
	local buildings = {}
	local owner = 0
	local money = 0
	local minerals = 0
	buildingOn = 0
	cleanImg()
	for i = 1, #sc_cities do
		if id == sc_cities[i].cityid then
			ctype = sc_cities[i].country
			buildings = sc_cities[i].buildings
			owner = sc_cities[i].owner
		end
	end
	if owner == sc_local[2] then
		money = sc_players[sc_local[2]].money
		minerals = sc_players[sc_local[2]].minerals
		displayNewImage( "img/countries/"..ctype.."/city_bg.png", display.contentCenterX, display.contentCenterY )
		for i = 1, #buildings do
			local b = displayNewImage( "img/countries/"..ctype.."/city_"..buildings[i]..".png", countries[ctype][2][buildings[i]][1], countries[ctype][2][buildings[i]][2] )
			b.t = buildings[i]
			b.c = ctype
			b.i = id
			if inside ~= 2 then
				b:addEventListener("touch", buildingTouch)
			end
		end
		slideRender(id)
		if inside ~= 2 then
			inside = os.time()
		end
		local control, ehero = 0, 0
		for x = 1, #sc_map do
			for y = 1, #sc_map[1] do
				if sc_map[x] ~= nil and sc_map[x][y] ~= nil and sc_map[x][y][3] == 1 and sc_map[x][y][4] == id then
					for h = 1, #sc_heroes do
						if sc_heroes[h].pos.x == x and sc_heroes[h].pos.y == y then
							control = sc_heroes[h].owner
							ehero = h
						end
					end
				end
			end
		end
		if control ~= 0 and control ~= sc_local[2] then
			local att = displayNewImage( "img/attack.png", 64, 24 )
			att.enemy = control
			att.ehid = ehero
			att.cityid = id
			att:addEventListener("touch", doRebel)
		end
		local t = displayNewText( "Your monies: "..money.." | Your mineralz: "..minerals, display.contentCenterX, 14, "Arial", 16)
		local g = gui( t.width+15, t.height+15, t.x, t.y, "", "1", 64 )
		g.alpha = 0.6
		t:toFront()
		displayNewImage( "img/exit.png", 24, 24 ):addEventListener("touch", displayScenarioAlt)
	else
		displayScenario()
	end
end
function doRebel(event)
	if event.phase == "ended" then
		local a = 0
		for i = 1, #sc_cities[event.target.cityid].army do
			if sc_cities[event.target.cityid].army[i][3] > 0 then
				a = a+1
			end
		end
		if a > 0 then
			prepareBattle2(0, event.target.ehid, "desert", event.target.cityid, 0, 0)
		else
			displayCastleSC( event.target.id )
		end
	end
end
local slSel = {0, 0}
local pos = {0, 0}
function slideRender(id)
	if inside ~= 2 then
		local sld = displayNewImage( "img/slide.png", 480-16, 160, 11 )
		sld:scale(1, 2)
		sld.castleid = id
		sld:addEventListener("touch", slideTouch1)
		local arr = displayNewImage( "img/arrow.png", 480-14, 160, 11 )
	elseif inside == 2 then
		local cpos = {264-432, 160}
		local sld = displayNewImage( "img/slide.png", cpos[1]+200, cpos[2], 11 )
		sld:scale(1, 2)
		sld.castleid = id
		sld:addEventListener("touch", slideTouch2)
		local arr = displayNewImage( "img/arrow.png", cpos[1]+202, cpos[2], 11 )
		arr.rotation = 180
		gui(432, 304, cpos[1]+432, cpos[2], "", 1)
		--
		for x = 1, #sc_map do
			for y = 1, #sc_map[1] do
				if sc_map[x] ~= nil and sc_map[x][y] ~= nil and sc_map[x][y][3] == 1 then
					if sc_map[x][y][4] == id then
						pos = {x, y}
					end
				end
			end
		end
		for i = 1, 5 do
			local style = 1
			if slSel[1] == i and slSel[2] == 1 then
				style = 2
			end
			local b = gui(64, 64, cpos[1]+202+(i*74), cpos[2]-80, "", style)
			b.pos = {i, 1}
			b.castleid = id
			for i = 1, #sc_cities do
				if sc_cities[i].cityid == id then
					id2 = i
				end
			end
			b:addEventListener("touch", slideSelect)
			displayNewImage( "img/map/building/1.png", cpos[1]+202+(i*74), cpos[2]-80, 11).alpha = 0.5
			if sc_cities[id2].army ~= nil and sc_cities[id2].army[i] ~= nil and sc_cities[id2].army[i][1] ~= 0 then
				local a = sc_cities[id2].army[i]
				displayNewImage( "img/countries/"..a[1].."/"..a[2]..".png", cpos[1]+202+(i*74), cpos[2]-80, 11)
				displayNewText( a[3], cpos[1]+202+(i*74)+20, cpos[2]-80+20, "Arial", 12)
			end
		end
		local hin = 0
		for i = 1, 5 do
			local style = 1
			if slSel[1] == i and slSel[2] == 2 then
				style = 2
			end
			local b = gui(64, 64, cpos[1]+202+(i*74), cpos[2]+80, "", style)
			b.pos = {i, 2}
			b.castleid = id

			b:addEventListener("touch", slideSelect)
			for h = 1, #sc_heroes do
				if sc_heroes[h].pos.x == pos[1] and sc_heroes[h].pos.y == pos[2] then
					hin = 1
					displayNewImage("img/countries/"..heroes[sc_heroes[h].hid].country.."/1.png", cpos[1]+202+(i*74), cpos[2]+80, 11).alpha = 0.5
					if sc_heroes[h].army[i] ~= nil and sc_heroes[h].army[i][1] ~= 0 then
						local a = sc_heroes[h].army[i]
						displayNewImage( "img/countries/"..a[1].."/"..a[2]..".png", cpos[1]+202+(i*74), cpos[2]+80, 11)
						displayNewText( a[3], cpos[1]+202+(i*74)+20, cpos[2]+80+20, "Arial", 12)
					end
				end
			end
			if hin == 0 then
				displayNewImage("img/exit.png", cpos[1]+202+(i*74), cpos[2]+80, 11).alpha = 0.5
			end
		end
	end
end
function slideSelect(event)
	if event.phase == "ended" then
		if slSel[1] == 0 and slSel[2] == 0 then
			slSel = event.target.pos
			displayCastleSC( event.target.castleid )
		elseif slSel[1] == event.target.pos[1] and slSel[2] == event.target.pos[2] then
			slSel = {0, 0}
		else
			local id = 0
			for i = 1, #sc_cities do
				if sc_cities[i].cityid == event.target.castleid then
					id = i
				end
			end
			if slSel[2] == 2 then
				for h = 1, #sc_heroes do
					if sc_heroes[h].pos.x == pos[1] and sc_heroes[h].pos.y == pos[2] then
						if sc_heroes[h].army[slSel[1]] ~= nil and sc_heroes[h].army[slSel[1]][1] ~= 0 then
							if event.target.pos[2] == 2 then
								if sc_heroes[h].army[event.target.pos[1]] ~= nil and sc_heroes[h].army[event.target.pos[1]][1] ~= 0 then
									if sc_heroes[h].army[event.target.pos[1]][1] == sc_heroes[h].army[slSel[1]][1] and sc_heroes[h].army[event.target.pos[1]][2] == sc_heroes[h].army[slSel[1]][2] then
										sc_heroes[h].army[event.target.pos[1]][3] = sc_heroes[h].army[event.target.pos[1]][3]+sc_heroes[h].army[slSel[1]][3]
										sc_heroes[h].army[slSel[1]] = nil
									else
										slSel = event.target.pos
									end
								else
									sc_heroes[h].army[event.target.pos[1]] = sc_heroes[h].army[slSel[1]]
									sc_heroes[h].army[slSel[1]] = nil
								end
							elseif event.target.pos[2] == 1 then
								if sc_cities[id].army[event.target.pos[1]] ~= nil and sc_cities[id].army[event.target.pos[1]][1] ~= 0 then
									if sc_cities[id].army[event.target.pos[1]][1] == sc_heroes[h].army[slSel[1]][1] and sc_cities[id].army[event.target.pos[1]][2] == sc_heroes[h].army[slSel[1]][2] then
										sc_cities[id].army[event.target.pos[1]][3] = sc_heroes[h].army[slSel[1]][3]
										sc_heroes[h].army[slSel[1]] = nil
									else
										slSel = event.target.pos
									end
								else
									sc_cities[id].army[event.target.pos[1]] = sc_heroes[h].army[slSel[1]]
									sc_heroes[h].army[slSel[1]] = nil
								end
							end
						else
							slSel = event.target.pos
						end
					end
				end
			elseif slSel[2] == 1 then
				if sc_cities[id].army[slSel[1]] ~= nil and sc_cities[id].army[slSel[1]][1] ~= 0 then
					if event.target.pos[2] == 1 then
						if sc_cities[id].army[event.target.pos[1]] ~= nil and sc_cities[id].army[event.target.pos[1]][1] ~= 0 then
							if sc_cities[id].army[slSel[1]][1] == sc_cities[id].army[event.target.pos[1]][1] and sc_cities[id].army[slSel[1]][2] == sc_cities[id].army[event.target.pos[1]][2] then
								sc_cities[id].army[event.target.pos[1]][3] = sc_cities[id].army[event.target.pos[1]][3]+sc_cities[id].army[slSel[1]][3]
								sc_cities[id].army[slSel[1]] = nil
							else
								slSel = event.target.pos
							end
						else
							sc_cities[id].army[event.target.pos[1]] = sc_cities[id].army[slSel[1]]
							sc_cities[id].army[slSel[1]] = nil
						end
					elseif event.target.pos[2] == 2 then
						for h = 1, #sc_heroes do
							if sc_heroes[h].pos.x == pos[1] and sc_heroes[h].pos.y == pos[2] then
								if sc_heroes[h].army[event.target.pos[1]] ~= nil and sc_heroes[h].army[event.target.pos[1]][1] ~= 0 then
									if sc_heroes[h].army[event.target.pos[1]][1] == sc_cities[id].army[slSel[1]][1] and sc_heroes[h].army[event.target.pos[1]][2] == sc_cities[id].army[slSel[1]][2] then
										sc_heroes[h].army[event.target.pos[1]][3] = sc_heroes[h].army[event.target.pos[1]][3]+sc_cities[id].army[slSel[1]][3]
										sc_cities[id].army[slSel[1]] = nil
									else
										slSel = event.target.pos
									end
								else
									sc_heroes[h].army[event.target.pos[1]] = sc_cities[id].army[slSel[1]]
									sc_cities[id].army[slSel[1]] = nil
								end
							end
						end
					end
				else
					slSel = event.target.pos
				end
			end
			slSel = {0, 0}
		end
		displayCastleSC( event.target.castleid )
	end
end
function slideTouch1(event)
	if event.phase == "ended" and (inside ~= 2 and os.time() > inside) then
		inside = 2
		displayCastleSC( event.target.castleid )
	end
end
function slideTouch2(event)
	if event.phase == "ended" and (inside == 2) then
		inside = 0
		slSel = {0, 0}
		displayCastleSC( event.target.castleid )
	end
end
function tavernTouch(id)
	displayCastleSC( id )
	for i = 1, #sc_cities do
		if id == sc_cities[i].cityid then
			ctype = sc_cities[i].country
			owner = sc_cities[i].owner
		end
	end
	gui( 360, 300, display.contentCenterX, display.contentCenterY, "Tavern", 1 )
	newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
	local h_array = {}
	for h = 1, #heroes do
		if heroes[h].country == ctype or (heroes[h].allowed ~= nil and heroes[h].allowed == ctype) then
			local w = 1
			for i = 1, #sc_heroes do
				if sc_heroes[i].hid == h and sc_heroes[i].owner == owner then
					w = 0
				end
			end
			if w == 1 then
				h_array[#h_array+1] = h
			end
		end
	end
	for y = 1, 3 do
		for x = 1, 4 do
			local num = x+((y-1)*4)
			local x1, y1 = display.contentCenterX-175+(x*70), display.contentCenterY-150+(y*70)
			local g = gui( 64, 64, x1, y1, "", 1 )
			if #h_array >= num then
				g.hid = h_array[num]
				g.cityid = id
				g:addEventListener("touch", buyHero)
				local hi = heroes[h_array[num]]
				displayNewImage( "img/countries/"..hi.country.."/1.png", x1, y1 )
				if #hi.attr > 0 then
					for a = 1, #hi.attr do
						displayNewImage( "img/attributes/"..hi.attr[a]..".png", x1, y1 )
					end
				end
			end
		end
	end
end
function buyHero( event )
	if event.phase == "ended" then
		local city_space = 1
		local pos = {1, 1}
		for x = 1, #sc_map do
			for y = 1, #sc_map[x] do
				if sc_map[x][y][3] == 1 and sc_map[x][y][4] == event.target.cityid then
					pos[1] = x
					pos[2] = y
					for h = 1, #sc_heroes do
						if sc_heroes[h].pos.x == x and sc_heroes[h].pos.y == y then
							city_space = 0
						end
					end
				end
			end
		end
		local ow = 0
		for c = 1, #sc_cities do
			if sc_cities[c].cityid == event.target.cityid then
				ow = sc_cities[c].owner
			end
		end
		if city_space == 1 then
			if sc_players[ow].money >= 2500 then
				local d = 0
				sc_players[ow].money = sc_players[ow].money-2500
				for i = 1, #sc_heroes do
					if sc_heroes[i] == nil then
						local ct = heroes[event.target.hid].country
						if heroes[event.target.hid].allowed ~= nil then ct = heroes[event.target.hid].allowed end
						sc_heroes[i] = {id = i, hid = event.target.hid, owner = ow, level = 1, xp = 0, army = {[1] = {ct, 1, 13}, [2] = {ct, 2, 5}}, items = {}, pos = {x = pos[1], y = pos[2]}, stamina = 5, mana = 0, spells = {}, commander = 0}
						d = 1
					end
				end
				if d == 0 then
					local ct = heroes[event.target.hid].country
					if heroes[event.target.hid].allowed ~= nil then ct = heroes[event.target.hid].allowed end
					local id, id2 = 0, 1
					while id == 0 do
						local approve = 1
						for hs = 1, #sc_heroes do
							if sc_heroes[hs].id == id2 then
								id2 = id2 + 1
								approve = 0
							end
						end
						if approve == 1 then
							id = id2
						end
					end
					sc_heroes[#sc_heroes+1] = {id = id, hid = event.target.hid, owner = ow, level = 1, xp = 0, army = {[1] = {ct, 1, 13}, [2] = {ct, 2, 5}}, items = {}, pos = {x = pos[1], y = pos[2]}, stamina = 5, mana = 0, spells = {}}
				end
				displayCastleSC( event.target.cityid )
			end
		end
	end
end
function buildingTouch( event )
	if event.phase == "ended" and (inside ~= 1 and os.time() > inside) and buildingOn == 0 then
		inside = 1
		local btype = event.target.t
		local ctype = event.target.c
		local id = event.target.i
		displayCastleSC( id )
		if btype == "m" then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			local idd = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					idd = i
				end
			end
			local infoC = sc_cities[idd]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, "City Hall", 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+120, "Tavern", 20, "Arial", tavernTouch, {id}, 128)
			local bldgs = {"m", "1", "2", "3", "4", "5"}
			local bldgs2 = {0, "1u", "2u", "3u", "4u", "5u"}
			local bldgs2 = {0, 0, 0, 0, 0, 0}
			for j = 1, 3 do
				for i = 1, 5 do
					local num = i+((j-1)*5)
					if num <= #bldgs and num > 0 then
						local name = bldgs[num]
						if isInArray(name, infoC.buildings) == true then
							if bldgs2[num] ~= 0 then
								name = bldgs2[num]
								if isInArray(bldgs2[num], infoC.buildings) == true then
									for i = 1, #infoC.buildings do
									end
									gui( 48, 48, display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20, "", 2 )
								else
									gui( 48, 48, display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20, "", 1 )
								end
							else
								gui( 48, 48, display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20, "", 2 )
							end
						else
							gui( 48, 48, display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20, "", 1 )
						end
						local b = displayNewImage( "img/countries/"..ctype.."/city_"..bldgs[num]..".png", display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20 )
						b:scale( 36/b.contentWidth, 36/b.contentHeight )
						local b = displayNewImage( "img/countries/"..ctype.."/city_"..name..".png", display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20 )
						b:scale( 36/b.contentWidth, 36/b.contentHeight )
						b.type = name
						b.id = idd
						local c = displayNewText( countries[event.target.c][2][name][3], display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+41, "Arial", 9)
						if isInArray(bldgs[num], infoC.buildings) == true and (isInArray(bldgs2[num], infoC.buildings) == true or bldgs2[num] == 0) then
							c:setFillColor( 0, 0, 0 )
						else
							b:addEventListener("touch", buybuildingTouch)
							c:setFillColor( 1, 1, 1 )
						end
					else
						gui( 48, 48, display.contentCenterX+(48+8)*(i-3), display.contentCenterY+(48+8)*(j-3)+20, "", 1 )
					end
				end
			end
			gui( 48*5, 48, display.contentCenterX, display.contentCenterY+(48+8)*(4-3)+20, "", 1 )
		elseif isInArray(btype, {"1", "1u"}) == true then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			local infoC = countries[event.target.c][1][1]
			local infoB = countries[event.target.c][2][btype]
			local av = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					av = sc_cities[i].buyable[1]
				end
			end
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			gui( 48, 48, display.contentCenterX-130, display.contentCenterY-86, "", 1 )
			local b = displayNewImage( "img/countries/"..event.target.c.."/".. 1 ..".png", display.contentCenterX-130, display.contentCenterY-86 )
			if b ~= nil then
				b:scale( 32/b.contentWidth, 32/b.contentHeight )
			end
			displayNewText( infoC.name .."\nAttack: "..infoC.att.."\nDefense: "..infoC.def.."\nSpeed: "..infoC.sp.."\nAccuracy: "..infoC.acc.."\n\nCost: ".. infoC.cost.money .." gold and "..infoC.cost.minerals.." minerals\n\nAmount: ".. av .."", display.contentCenterX-75, display.contentCenterY, "Arial", 12)
			newButton( display.contentCenterX-72, display.contentCenterY+90, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+90, "Buy!", 20, "Arial", countBar, {id, 1}, 128)
			maxcount = av
		elseif isInArray(btype, {"2", "2u"}) == true then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			local infoC = countries[event.target.c][1][2]
			local av = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					av = sc_cities[i].buyable[2]
				end
			end
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			gui( 48, 48, display.contentCenterX-130, display.contentCenterY-86, "", 1 )
			local b = displayNewImage( "img/countries/"..event.target.c.."/".. 2 ..".png", display.contentCenterX-130, display.contentCenterY-86 )
			b:scale( 32/b.contentWidth, 32/b.contentHeight )
			displayNewText( infoC.name .."\nAttack: "..infoC.att.."\nDefense: "..infoC.def.."\nSpeed: "..infoC.sp.."\nAccuracy: "..infoC.acc.."\n\nCost: ".. infoC.cost.money .." gold and "..infoC.cost.minerals.." minerals\n\nAmount: ".. av .."", display.contentCenterX-75, display.contentCenterY, "Arial", 12)
			newButton( display.contentCenterX-72, display.contentCenterY+90, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+90, "Buy!", 20, "Arial", countBar, {id, 2}, 128)
			maxcount = av
		elseif isInArray(btype, {"3", "3u"}) == true then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			local infoC = countries[event.target.c][1][3]
			local av = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					av = sc_cities[i].buyable[3]
				end
			end
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			gui( 48, 48, display.contentCenterX-130, display.contentCenterY-86, "", 1 )
			local b = displayNewImage( "img/countries/"..event.target.c.."/".. 3 ..".png", display.contentCenterX-130, display.contentCenterY-86 )
			b:scale( 32/b.contentWidth, 32/b.contentHeight )
			displayNewText( infoC.name .."\nAttack: "..infoC.att.."\nDefense: "..infoC.def.."\nSpeed: "..infoC.sp.."\nAccuracy: "..infoC.acc.."\n\nCost: ".. infoC.cost.money .." gold and "..infoC.cost.minerals.." minerals\n\nAmount: ".. av .."", display.contentCenterX-75, display.contentCenterY, "Arial", 12)
			newButton( display.contentCenterX-72, display.contentCenterY+90, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+90, "Buy!", 20, "Arial", countBar, {id, 3}, 128)
			maxcount = av
		elseif isInArray(btype, {"4", "4u"}) == true then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			local infoC = countries[event.target.c][1][4]
			local av = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					av = sc_cities[i].buyable[4]
				end
			end
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			gui( 48, 48, display.contentCenterX-130, display.contentCenterY-86, "", 1 )
			local b = displayNewImage( "img/countries/"..event.target.c.."/".. 4 ..".png", display.contentCenterX-130, display.contentCenterY-86 )
			b:scale( 32/b.contentWidth, 32/b.contentHeight )
			displayNewText( infoC.name .."\nAttack: "..infoC.att.."\nDefense: "..infoC.def.."\nSpeed: "..infoC.sp.."\nAccuracy: "..infoC.acc.."\n\nCost: ".. infoC.cost.money .." gold and "..infoC.cost.minerals.." minerals\n\nAmount: ".. av .."", display.contentCenterX-75, display.contentCenterY, "Arial", 12)
			newButton( display.contentCenterX-72, display.contentCenterY+90, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+90, "Buy!", 20, "Arial", countBar, {id, 4}, 128)
			maxcount = av
		elseif isInArray(btype, {"5", "5u"}) == true then
			buildingOn = 1
			local infoB = countries[event.target.c][2][btype]
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			newButton( display.contentCenterX-72, display.contentCenterY+120, "Exit", 20, "Arial", exitTouch, {id}, 128)
			local infoC = countries[event.target.c][1][5]
			local av = 0
			for i = 1, #sc_cities do
				if id == sc_cities[i].cityid then
					av = sc_cities[i].buyable[5]
				end
			end
			gui( 360, 300, display.contentCenterX, display.contentCenterY, infoB[3], 1 )
			gui( 48, 48, display.contentCenterX-130, display.contentCenterY-86, "", 1 )
			local b = displayNewImage( "img/countries/"..event.target.c.."/".. 5 ..".png", display.contentCenterX-130, display.contentCenterY-86 )
			b:scale( 32/b.contentWidth, 32/b.contentHeight )
			displayNewText( infoC.name .."\nAttack: "..infoC.att.."\nDefense: "..infoC.def.."\nSpeed: "..infoC.sp.."\nAccuracy: "..infoC.acc.."\n\nCost: ".. infoC.cost.money .." gold and "..infoC.cost.minerals.." minerals\n\nAmount: ".. av .."", display.contentCenterX-75, display.contentCenterY, "Arial", 12)
			newButton( display.contentCenterX-72, display.contentCenterY+90, "Exit", 20, "Arial", exitTouch, {id}, 128)
			newButton( display.contentCenterX+72, display.contentCenterY+90, "Buy!", 20, "Arial", countBar, {id, 5}, 128)
			maxcount = av
		else
			inside = 0
		end
	end
end
local bbTtxt = nil
function buybuildingTouch( event )
	if event.phase == "ended" then
		local infoC = sc_cities[event.target.id]
		local btype = event.target.type
		if isInArray(btype, infoC.buildings) ~= true then
			local cost = countries[infoC.country][2][btype][4]
			local owner = 0
			for i = 1, #sc_players do
				if infoC.owner == sc_players[i].id then
					owner = i
				end
			end
			local bldgs = {"m", "1", "2", "3", "4", "5"}
			local idd = 0
			for i = 1, #bldgs do
				if bldgs[i] == btype then
					idd = i
				end
			end
			if sc_cities[event.target.id].built == 0 and sc_players[owner].money >= cost.money and sc_players[owner].minerals >= cost.minerals and (isInArray(bldgs[idd-1], sc_cities[event.target.id].buildings) == true or isInArray(idd, {2,3,4,5,6}) ~= true) then
				table.insert(sc_cities[event.target.id].buildings, btype)
				sc_players[owner].money = sc_players[owner].money-cost.money
				sc_players[owner].minerals = sc_players[owner].minerals-cost.minerals
				sc_cities[event.target.id].built = 1
			end
			displayCastleSC( event.target.id )
		end
	else
		local infoC = sc_cities[event.target.id]
		local btype = event.target.type
		local cost = countries[infoC.country][2][btype][4]
		if bbTtxt ~= nil then
			bbTtxt.x = 5000
			bbTtxt.y = 5000
		end
		bbTtxt = nil
		bbTtxt = displayNewText( cost.money.." gold & "..cost.minerals.." resources", display.contentCenterX, display.contentCenterY+(48+8)*(4-3)+20, "Arial", 10 )
	end
end
function countBar( cityid, lvl )
	displayCastleSC( cityid )
	buildingOn = 1
	if count > maxcount then count = maxcount end
	if count < 0 then count = 0 end
	inShop = 2
	gui( 192, 72, display.contentCenterX, display.contentCenterY+12, "", 1 )
	displayNewText( "Amount: "..count, display.contentCenterX, display.contentCenterY-16, "Arial", 18 )
	for i = 1, 20 do
		local b = displayNewImage( "img/bar/light.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY)
		b.id = cityid
		b.lvl = lvl
		b:addEventListener( "touch", countBar2)
		local b = displayNewImage( "img/bar/light.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY-2)
		b.id = cityid
		b.lvl = lvl
		b:addEventListener( "touch", countBar2)
	end
	for i = 1, 20 do
		if math.floor(math.floor((100*count)/maxcount)/5) == i then
			local b = displayNewImage( "img/bar/dark.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY)
			b.id = cityid
			b.lvl = lvl
			b:addEventListener( "touch", countBar2)
			local b = displayNewImage( "img/bar/dark.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY-2)
			b.id = cityid
			b.lvl = lvl
			b:addEventListener( "touch", countBar2)
			local b = displayNewImage( "img/bar/dot.png", display.contentCenterX-(192/2)+16+(8*i), display.contentCenterY-1)
			b.id = cityid
			b.lvl = lvl
			b:scale( 2, 2 )
		elseif math.floor((100*count)/maxcount) > i*5 then
			local b = displayNewImage( "img/bar/dark.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY)
			b.id = cityid
			b.lvl = lvl
			b:addEventListener( "touch", countBar2)
			local b = displayNewImage( "img/bar/dark.png", display.contentCenterX-(192/2)+12+(8*i), display.contentCenterY-2)
			b.id = cityid
			b.lvl = lvl
			b:addEventListener( "touch", countBar2)
		end
	end
	local b = displayNewText( " - ", display.contentCenterX-66, display.contentCenterY+14, "Arial", 20 )
	b.id = cityid
	b.lvl = lvl
	b:addEventListener( "touch", countBar3)
	local b = displayNewText( " + ", display.contentCenterX+70, display.contentCenterY+14, "Arial", 20 )
	b.id = cityid
	b.lvl = lvl
	b:addEventListener( "touch", countBar4)

	local b = displayNewText( " Accept ", display.contentCenterX, display.contentCenterY+17, "Arial", 18 )
	b.id = cityid
	b.lvl = lvl
	b:addEventListener( "touch", countBar5)
	
	local b = displayNewText( " Cancel ", display.contentCenterX+75, display.contentCenterY+40, "Arial", 12 )
	b.id = cityid
	b:addEventListener( "touch", exitTouch2)
end
function countBar2( event )
	--if event.phase == "ended" then
		count = math.ceil((event.x-display.contentCenterX+192/2)*maxcount/180)
		countBar( event.target.id, event.target.lvl )
	--end
end
function countBar3( event )
	if event.phase == "ended" then
		count = count-1
		countBar( event.target.id, event.target.lvl )
	end
end
function countBar4( event )
	if event.phase == "ended" then
		count = count+1
		countBar( event.target.id, event.target.lvl )
	end
end
function countBar5( event )-- target: lvl (unit), id (city) / g - count ||||| money >= cost.money*count and minerals >= cost.minerals*count / cost = countries[country][1][lvl].cost / sc_cities[idd].buyable[lvl]
	if event.phase == "ended" then
		local owner = 0
		local idd = 0
		local lvl = event.target.lvl
		for i = 1, #sc_cities do
			if event.target.id == sc_cities[i].cityid then
				owner = sc_cities[i].owner
				idd = i
				country = sc_cities[i].country
			end
		end
		for i = 1, #sc_players do
			if owner == sc_players[i].id then
				money = sc_players[i].money
				minerals = sc_players[i].minerals
			end
		end
		local cost = countries[country][1][lvl].cost
		if count > 0 and money >= cost.money*count and minerals >= cost.minerals*count then
			local d, c = 0, 0
			while d ~=  2 do
				c = c+1
				if c == 6 then
					if d == 0 then
						d = 1
						c = 1
					elseif d == 1 then
						d = 3
						break
					end
				end
				--
				if d == 0 then
					if sc_cities[idd].army[c] ~= nil and sc_cities[idd].army[c][1] == sc_cities[idd].country and sc_cities[idd].army[c][2] == lvl then
						sc_cities[idd].army[c][3] = sc_cities[idd].army[c][3]+count
						d = 2
					end
				elseif d == 1 then
					if sc_cities[idd].army[c] == nil then
						sc_cities[idd].army[c] = {sc_cities[idd].country, lvl, count}
						d = 2
					end
				end
			end
			if d == 2 then
				if sc_cities[idd].buyable[lvl]-count < 0 then
					sc_cities[idd].buyable[lvl] = 0
				else
					sc_cities[idd].buyable[lvl] = sc_cities[idd].buyable[lvl]-count
				end
				sc_players[owner].money = sc_players[owner].money-(cost.money*count)
				sc_players[owner].minerals = sc_players[owner].minerals-(cost.minerals*count)
				count = 0
			end
			exitTouch( event.target.id )
		elseif minerals < cost.minerals*count and money < cost.money*count then
			cleanImg(63)
			local t = displayNewText( "Not enough monies and minerals.", display.contentCenterX, 64, "Arial", 16, 63)
			local g = gui( t.width+15, t.height+15, t.x, t.y, "", "1", 63 )
			g.alpha = 0.8
			t:toFront()
		elseif money < cost.money*count then
			cleanImg(63)
			local t = displayNewText( "Not enough monies.", display.contentCenterX, 64, "Arial", 16, 63)
			local g = gui( t.width+15, t.height+15, t.x, t.y, "", "1", 63 )
			g.alpha = 0.8
			t:toFront()
		elseif minerals < cost.minerals*count then
			cleanImg(63)
			local t = displayNewText( "Not enough minerals.", display.contentCenterX, 64, "Arial", 16, 63)
			local g = gui( t.width+15, t.height+15, t.x, t.y, "", "1", 63 )
			g.alpha = 0.8
			t:toFront()
		elseif count <= 0 then
			cleanImg(63)
			local t = displayNewText( "Select more units to buy.", display.contentCenterX, 64, "Arial", 16, 63)
			local g = gui( t.width+15, t.height+15, t.x, t.y, "", "1", 63 )
			g.alpha = 0.8
			t:toFront()
		end
	end
end
function exitTouch( id )
	inside = 0
	displayCastleSC( id )
end
function exitTouch2( event )
	inside = 0
	displayCastleSC( event.target.id )
end
function checkGameEnded()
	if sc_local[7] == 2 then
		local array = {}
		for k,v in pairs (sc_heroes) do
			if isInArray(v.owner, array) == false and v.commander == 1 then
				table.insert(array, v.owner)
			end
		end
		for i = 1, #sc_players do
			if sc_players[i].alive == 1 and isInArray(i, array) == false then
				killPlayer(i)
			end
		end
		if #array == 1 then
			scEndScreen( array[1], 2 )
			return true
		end
	elseif sc_local[7] == 3 then
		if sc_map[sc_local[8][1]][sc_local[8][2]][6] ~= 0 then
			scEndScreen( sc_map[sc_local[8][1]][sc_local[8][2]][6], 3 )
			return true
		end
	elseif sc_local[7] == 4 then
		local dat = sc_map[sc_local[8][1]][sc_local[8][2]][4]
		if dat[1] == sc_local[4][1] and dat[2] == sc_local[4][2] and dat[3] == sc_local[4][3] and dat[4] == sc_local[4][3] then
			if sc_map[sc_local[8][1]][sc_local[8][2]][6] ~= 0 then
				scEndScreen( sc_map[sc_local[8][1]][sc_local[8][2]][6], 4 )
				return true
			else
				print("total failure! nobody holds base")
			end
		end
	end
	if	isInArray(sc_local[7], {1, 3, 4}) == true then
		local array = {}
		for k,v in pairs (sc_heroes) do
			if isInArray(v.owner, array) == false then
				table.insert(array, v.owner)
			end
		end
		for k,v in pairs (sc_cities) do
			if isInArray(v.owner, array) == false then
				table.insert(array, v.owner)
			end
		end
		for i = 1, #sc_players do
			if sc_players[i].alive == 1 and isInArray(i, array) == false then
				killPlayer(i)
			end
		end
		if #array == 1 then
			scEndScreen( array[1], 1 )
			return true
		end
	end
end
function killPlayer(id)
	for k, v in pairs( sc_heroes) do
		if v.owner == id then
			local d = 0
			local heroarr = {}
			for i = 1, #sc_heroes do
				if k == i then
					d = 1
				else
					heroarr[i-d] = sc_heroes[i]
				end
			end
			sc_heroes = nil
			sc_heroes = {}
			sc_heroes = deepcopy(heroarr)
		end
	end
	for k, v in pairs(sc_cities) do
		if v.owner == id then
			sc_cities[k].army = {}
		end
	end
	sc_players[id].alive = 0
end
function scEndScreen( who, how )
	local methods = {"Kill others", "Kill commanders", "Capture base", "Hold base"}
	cleanImg()
	gui( 480, 320, 240, 160, "Results", 1 )
	displayNewText( methods[sc_local[7]], display.contentCenterX, 60, "Arial", 20 ):setFillColor(0,1,0)
	displayNewText( "Player ".. who, display.contentCenterX, 90, "Arial", 16 )
	displayNewText( "...won by ".. methods[how], display.contentCenterX, 110, "Arial", 16 )

	newButton( display.contentCenterX, 300, "Exit", 18, "Arial", menuDs, {})
end
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
------ AI PART HERE
function aiTurn()
	if sc_players[sc_local[2]].type ~= 0 then
		local checklist = {
			mine = {need = 0, get = 0},
			delay = 0,
			capturedFlag = false,
			}
		----------------------------------------------------------------------------------------------------------------------------
		-- building 
		for c = 1, #sc_cities do 
			if sc_cities[c].owner == sc_local[2] and sc_cities[c].built == 0 then
				local btype = "m"
				if isInArray("2", sc_cities[c].buildings) == false then btype = "2"
				elseif isInArray("3", sc_cities[c].buildings) == false then btype = "3" 
				elseif isInArray("4", sc_cities[c].buildings) == false then btype = "4" 
				elseif isInArray("5", sc_cities[c].buildings) == false then btype = "5" end
				if btype ~= "m" then buybuildingTouch( {phase = "ended", target = {id = c, type = btype}} ) end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- buying units
		for c = 1, #sc_cities do
			if sc_cities[c].owner == sc_local[2] then
				local b1 = {"1", "2", "3", "4", "5"}
				for b = #b1, 1, -1 do
					if isInArray(b1[b], sc_cities[c].buildings) == true then
						local mon, res = sc_players[sc_local[2]].money, sc_players[sc_local[2]].minerals
						local cost = countries[sc_players[sc_local[2]].country][1][tonumber(b1[b])].cost
						local maxC = sc_cities[c].buyable[tonumber(b1[b])]
						local canAfford = {math.floor(mon/cost.money), ((cost.minerals > 0 and math.floor(res/cost.minerals)) or 0) }
						table.sort(canAfford)
						local canBuy = {maxC, canAfford[2]}
						table.sort(canBuy)
						count = canBuy[1]
						countBar5( {phase = "ended", target = {lvl = tonumber(b1[b]), id = sc_cities[c].cityid}} )
					end
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- moving army from city to hero
		local function armyMoving()
			for x = 1, #sc_map do 
				for y = 1, #sc_map[x] do
					if sc_map[x][y][3] == 1 and sc_map[x][y][6] == sc_local[2] then
						for c = 1, #sc_cities do
							if sc_cities[c].cityid == sc_map[x][y][4] then
								local cid = sc_cities[c].cityid
								for h = 1, #sc_heroes do
									if sc_heroes[h].pos.x == x and sc_heroes[h].pos.y == y then
										pos = {x, y}
										for s, u in pairs(sc_cities[c].army) do
											local placed = 0
											slideSelect({phase = "ended", target = {castleid = cid, pos = {s, 1}}})
											for s1 = 1, 5 do
												if sc_heroes[h].army[s1] ~= nil then
													local u1 = sc_heroes[h].army[s1]
													if u[2] == u1[2] then
														placed = 1
														slideSelect({phase = "ended", target = {castleid = cid, pos = {s1, 2}}})
													end
												end
											end
											if placed == 0 then
												for i = 1, 5 do
													if sc_heroes[h].army[i] == nil then
														placed = 1
														slideSelect({phase = "ended", target = {castleid = cid, pos = {i, 2}}})
														break
													end
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- resources calculation
		lastStep_ = {0,0}
		for y = 1, #sc_map do 
			for x = 1, #sc_map[y] do
				if resources[sc_map[y][x][3]] ~= nil and sc_map[y][x][5] == sc_local[2] then
					checklist.mine.get = checklist.mine.get+resources[sc_map[y][x][3]].r
				end
			end
		end
		for c = 1, #sc_cities do
			if sc_cities[c].owner == sc_local[2] and sc_cities[c].built == 0 then 
				if isInArray("4", sc_cities[c].buildings) == false then checklist.mine.need = checklist.mine.need+5 end
				if isInArray("5", sc_cities[c].buildings) == false then checklist.mine.need = checklist.mine.need+15 end
			end
		end
		if checklist.mine.get == 0 then
			local mines__ = {}
			local map__ = {} 
			for x = 1, #sc_map do 
				map__[x] = {}
			end
			for x = 1, #sc_map do 
				for y = 1, #sc_map[x] do 
					if sc_map[x][y][2] ~= 0 then 
						map__[y][x] = 1 
					elseif sc_map[x][y][3] == 1 then
						map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][6]*100) -- [id gracza]01
					elseif sc_map[x][y][3] == 3 then
						map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][5]*100) -- [id gracza]03
					elseif sc_map[x][y][3] == 843 then
						map__[y][x] = 10000 
					elseif sc_map[x][y][3] ~= 0 then
						map__[y][x] = sc_map[x][y][3]
					else
						map__[y][x] = 0
					end
				end
			end
			for h = 1, #sc_heroes do
				local m = sc_heroes[h].owner*100+99
				if sc_heroes[h].owner == sc_local[2] then m = 1 end
				map__[sc_heroes[h].pos.y][sc_heroes[h].pos.x] = m
			end
			--for x = 1, #map__ do local row = "" for y = 1, #map__[x] do row = row..","..map__[x][y] end print(row) end -- PRINT map__
			for h = 1, #sc_heroes do -- finding all mines and pathfinding
				if sc_heroes[h].owner == sc_local[2] then
					for y = 1, #sc_map do
						for x = 1, #sc_map[y] do
							if resources[sc_map[y][x][3]] ~= nil and sc_map[y][x][5] ~= sc_local[2] then
								local walkable = function(v)
									if ((math.floor(v/100)) == sc_local[2] or (math.floor(v/100)*100) == 0 or ((v-(math.floor(v/100)*100)) == 1 and v > 1)) and v ~= 10000 and v ~= 1 then
									return true
									else
									return false
									end
								end
								local grid = Grid(map__)
								local myFinder = Pathfinder(grid, 'ASTAR', walkable)
								myFinder:setMode("ORTHOGONAL")
								local p = myFinder:getPath(sc_heroes[h].pos.x,sc_heroes[h].pos.y, y,x)
								local lenght_ = 0
								if p ~= nil then
									for node, count in p:nodes() do
										if count ~= 1 then
											lenght_ = lenght_+1
										end
									end
								end
								table.insert(mines__, {lenght_, y, x, p})
							end
						end
					end
					local l_, r_ = 1000, 0 -- finding closest mine
					for i = 1, #mines__ do
						local m_ = mines__[i]
						if m_[1] < l_ and m_[1] > 0 then
							l_ = m_[1]
							r_ = i
						end	
					end
					if r_ ~= 0 and mines__[r_][4] ~= nil then -- moving to closest mine
						local m_ = mines__[r_]
						local lastStep = {sc_heroes[h].pos.x, sc_heroes[h].pos.y}
						for node, count in m_[4]:nodes() do
							if count-1 <= sc_heroes[h].stamina and count ~= 1 then
								local function aiHeroTouch()
									if sc_heroes[h].stamina > 0 then
										st = system.getTimer()
										scHeroTouch( {phase = "ended", target = {hid = sc_heroes[h].id}} )
									end
								end
								local function aiHeroMove(event)
									if sc_heroes[h].stamina > 0 then
										local p = event.source
										heroMove( {phase = "ended", target = {px = p.gx-p.lx, py = p.gy-p.ly}} )
									end
								end
								timer.performWithDelay( 100+checklist.delay, aiHeroTouch)
								local t = timer.performWithDelay( 150+checklist.delay, aiHeroMove)
								t.gx = node:getX()
								t.lx = lastStep[1]
								t.gy = node:getY()
								t.ly = lastStep[2]
								checklist.delay = checklist.delay+100
								lastStep = {node:getX(), node:getY()}
							end
						end
						lastStep_ = deepcopy(lastStep)
					end
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- back to castle
		for h = 1, #sc_heroes do
			if sc_heroes[h].owner == sc_local[2] then
				local heroPower = 0
				for a = 1, #sc_heroes[h].army do
					heroPower = heroPower + (sc_heroes[h].army[a][2] * sc_heroes[h].army[a][3])
				end
				if heroPower <= 35 then
					local map__ = {} -- prepare grid-map
					local castles = {}
					for x = 1, #sc_map do 
						map__[x] = {}
					end
					for x = 1, #sc_map do 
						for y = 1, #sc_map[x] do 
							if sc_map[x][y][2] ~= 0 then 
								map__[y][x] = 1 
							elseif sc_map[x][y][3] == 1 then
								map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][6]*100) -- [id gracza]01
								castles[#castles+1] = {x, y, sc_map[x][y][6], 100, nil}
							elseif sc_map[x][y][3] == 3 then
								map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][5]*100) -- [id gracza]03
							elseif sc_map[x][y][3] == 843 then
								map__[y][x] = 10000 
							elseif sc_map[x][y][3] ~= 0 then
								map__[y][x] = sc_map[x][y][3]
							else
								map__[y][x] = 0
							end
						end
					end
					for h = 1, #sc_heroes do
						local m = sc_heroes[h].owner*100+99
						if sc_heroes[h].owner == sc_local[2] then m = 1 end
						map__[sc_heroes[h].pos.y][sc_heroes[h].pos.x] = m
					end -- end of preparing grid-map
					--
					for c = 1, #castles do
						local ci = castles[c]
						if ci[3] == sc_local[2] then
							local walkable = function(v)
							if ((math.floor(v/100)) == sc_local[2] or (math.floor(v/100)*100) == 0) and v ~= 10000 and v ~= 1 then
								return true
								else
								return false
								end
							end
							local grid = Grid(map__)
							local myFinder = Pathfinder(grid, 'ASTAR', walkable)
							myFinder:setMode("ORTHOGONAL")
							local p = myFinder:getPath(sc_heroes[h].pos.x,sc_heroes[h].pos.y, ci[1],ci[2])
							local lenght_ = 0
							if p ~= nil then
								for node, count in p:nodes() do
									if count ~= 1 then
										lenght_ = lenght_+1
									end
								end
							end
							castles[c][4] = lenght_
							castles[c][5] = p
						end
					end
					--
					local l_, r_ = 1000, 0 -- finding closest castle
					for i = 1, #castles do
						local m_ = castles[i]
						if m_[4] < l_ then
							l_ = m_[4]
							r_ = i
						end	
					end
					--
					if r_ ~= 0 and castles[r_][5] ~= nil and sc_heroes[h] ~= nil then -- moving to closest castle
						local m_ = castles[r_]
						local lastStep = {sc_heroes[h].pos.x, sc_heroes[h].pos.y}
						if lastStep_[1] ~= 0 and lastStep_[2] ~= 0 then lastStep = lastStep_ end
						for node, count in m_[5]:nodes() do
							if count-1 <= sc_heroes[h].stamina and count ~= 1 then
								local function aiHeroTouch()
									if sc_heroes[h].stamina > 0 then
										st = system.getTimer()
										scHeroTouch( {phase = "ended", target = {hid = sc_heroes[h].id}} )
									end
								end
								local function aiHeroMove(event)
									if sc_heroes[h].stamina > 0 then
										local p = event.source
										heroMove( {phase = "ended", target = {px = p.gx-p.lx, py = p.gy-p.ly}} )
									end
								end
								timer.performWithDelay( 100+checklist.delay, aiHeroTouch)
								local t = timer.performWithDelay( 150+checklist.delay, aiHeroMove)
								t.gx = node:getX()
								t.lx = lastStep[1]
								t.gy = node:getY()
								t.ly = lastStep[2]
								checklist.delay = checklist.delay+100
								lastStep = {node:getX(), node:getY()}
							end
						end
					end
					--
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- moving army from city to hero p2
		timer.performWithDelay( 100+checklist.delay, armyMoving)
		checklist.delay = checklist.delay+100
		----------------------------------------------------------------------------------------------------------------------------
		-- buy hero if none or less than 1/2 amount of castles
		local hAmount = 0
		local cAmount = 0
		local cityid = 0
		for k,v in pairs(sc_heroes) do
			if v.owner == sc_local[2] then
				hAmount = hAmount+1
			end
		end
		for k,v in pairs(sc_cities) do
			if v.owner == sc_local[2] then
				cityid = v.cityid
				cAmount = cAmount+1
			end
		end
		if hAmount < cAmount/2 then
			local h_array = {}
			for h = 1, #heroes do
				if heroes[h].country == sc_cities[cityid].country or (heroes[h].allowed ~= nil and heroes[h].allowed == sc_cities[cityid].country) then
					local w = 1
					for i = 1, #sc_heroes do
						if sc_heroes[i].hid == h and sc_heroes[i].owner == sc_local[2] then
							w = 0
						end
					end
					if w == 1 then
						h_array[#h_array+1] = h
					end
				end
			end
			if h_array[1] ~= nil then
				buyHero( {phase = "ended", target = {cityid = cityid, hid = h_array[1]}} )
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- wear best items
		local slots = {["head"] = 1, ["left"] = 2, ["right"] = 3, ["back"] = 4}
		local items_ = {{0, 0}, {0, 0}, {0, 0}, {0, 0}}
		for hid, h in pairs(sc_heroes) do
			if h.owner == sc_local[2] then
				local itanz = deepcopy(h.pocket)
				if #h.items > 0 then
					for i = 1, #h.items do
						itanz[#itanz+1] = h.items[i]
					end
				end
				if #itanz > 0 then
					for i = 1, #itanz do
						local itemPower, slot_ = 0, items[itanz[i]].slot
						for k, v in pairs(items[itanz[i]][2]) do
							itemPower = itemPower+v
						end
						if items_[slots[slot_]][1] < itemPower then
							items_[slots[slot_]] = {itemPower, i}
						end
					end
				end
				for i = 1, #items_ do
					if items_[i][2] <= #h.pocket and items_[i][1] ~= 0 and items_[i][2] ~= 0 then
						local slot, number = items[itanz[items_[i][2]]].slot, itanz[items_[i][2]]
						itemTouch( {phase = "ended", target = {slot = slot, hid = h}} )
						pocketTouch( {phase = "ended", target = {hid = h, number = number}} )
					end
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		-- 
		----------------------------------------------------------------------------------------------------------------------------
		-- modes: 1-standard, 2-kill commander, 3-capture tower, 4-hold tower until #date --- sc_local[7]
		-- fulfill objectives
		----------------------------------------------------------------------------------------------------------------------------
		if sc_local[7] == 1 then -- standard mode
		----------------------------------------------------------------------------------------------------------------------------
		elseif sc_local[7] == 2 then -- kill commander
			for h = 1, #sc_heroes do
				if sc_heroes[h].owner == sc_local[2] then
					local heroPower = 0
					for a = 1, #sc_heroes[h].army do
						heroPower = heroPower + (sc_heroes[h].army[a][2] * sc_heroes[h].army[a][3])
					end
					if heroPower >= 35 then
						--
						local map__ = {} -- prepare grid-map
						local cheroes = {}
						for x = 1, #sc_map do 
							map__[x] = {}
						end
						for x = 1, #sc_map do 
							for y = 1, #sc_map[x] do 
								if sc_map[x][y][2] ~= 0 then 
									map__[y][x] = 97
								elseif sc_map[x][y][3] == 1 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][6]*100) -- [id gracza]01
								elseif sc_map[x][y][3] == 3 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][5]*100) -- [id gracza]03
								elseif sc_map[x][y][3] == 843 then
									map__[y][x] = 98 
								elseif sc_map[x][y][3] ~= 0 then
									map__[y][x] = sc_map[x][y][3]
								else
									map__[y][x] = 0
								end
							end
						end
						for h = 1, #sc_heroes do
							local m = sc_heroes[h].owner*100+99
							if sc_heroes[h].owner == sc_local[2] then
								m = 1 
							else
								if sc_heroes[h].commander == 1 then table.insert(cheroes, {sc_heroes[h].pos.x, sc_heroes[h].pos.y, 1000, nil}) end
							end
							map__[sc_heroes[h].pos.y][sc_heroes[h].pos.x] = m
						end
						
						--for x = 1, #map__ do local row = ""  for y = 1, #map__[x] do  local add = map__[x][y] if string.len(add) == 1 then add = "  "..add elseif string.len(add) == 2 then add = " "..add end row = row..","..add end print(row) end -- PRINT map__
						
						--
						for c = 1, #cheroes do
							local ci = cheroes[c]
							--if ci[3] == sc_local[2] then
								local walkable = function(v)
									local id, owner = v, math.floor(v/100)
									if id > 100 then id = v-(math.floor(v/100)*100) end
									if owner == 0 then id = v end
									--id - itemid, owner - building owner
									-- 99 - hero
									-- 98 - wildball
									-- 97 - blocked (tree, bush etc)
									if (owner == sc_local[2] or owner == 0 or isInArray(id, {99, 0}) == true) and isInArray(id, {98, 97}) == false then
										return true
									else
										return false
									end
								end
								local grid = Grid(map__)
								local myFinder = Pathfinder(grid, 'ASTAR', walkable)
								myFinder:setMode("ORTHOGONAL")
								local p = myFinder:getPath(sc_heroes[h].pos.x,sc_heroes[h].pos.y, ci[1],ci[2])
								local lenght_ = 0
								if p ~= nil then
									for node, count in p:nodes() do
										if count ~= 1 then
											lenght_ = lenght_+1
										end
									end
								end
								cheroes[c][3] = lenght_
								cheroes[c][4] = p
							--end
						end
						--
						local l_, r_ = 1000, 0 -- finding closest commander
						for i = 1, #cheroes do
							local m_ = cheroes[i]
							if i > 0 and m_[3] < l_ then
								l_ = m_[3]
								r_ = i
							end	
						end
						--
						if r_ ~= 0 and cheroes[r_][4] ~= nil and sc_heroes[h] ~= nil then -- moving to closest castle
							local m_ = cheroes[r_]
							local lastStep = {sc_heroes[h].pos.x, sc_heroes[h].pos.y}
							if lastStep_[1] ~= 0 and lastStep_[2] ~= 0 then lastStep = lastStep_ end
							for node, count in m_[4]:nodes() do
								if count-1 <= sc_heroes[h].stamina and count ~= 1 then
									local function aiHeroTouch()
										if sc_heroes[h].stamina > 0 then
											st = system.getTimer()
											scHeroTouch( {phase = "ended", target = {hid = sc_heroes[h].id}} )
										end
									end
									local function aiHeroMove(event)
										if sc_heroes[h].stamina > 0 then
											local p = event.source
											heroMove( {phase = "ended", target = {px = p.gx-p.lx, py = p.gy-p.ly}} )
										end
									end
									timer.performWithDelay( 100+checklist.delay, aiHeroTouch)
									local t = timer.performWithDelay( 150+checklist.delay, aiHeroMove)
									t.gx = node:getX()
									t.lx = lastStep[1]
									t.gy = node:getY()
									t.ly = lastStep[2]
									checklist.delay = checklist.delay+100
									lastStep = {node:getX(), node:getY()}
								end
							end
						end
						--
					end
				end
			end
		----------------------------------------------------------------------------------------------------------------------------
		elseif sc_local[7] == 3 then -- capture tower
			for h = 1, #sc_heroes do
				if sc_heroes[h].owner == sc_local[2] then
					local heroPower = 0
					for a = 1, #sc_heroes[h].army do
						heroPower = heroPower + (sc_heroes[h].army[a][2] * sc_heroes[h].army[a][3])
					end
					if heroPower >= 35 then
						--
						local map__ = {} -- prepare grid-map
						local cheroes = {}
						for x = 1, #sc_map do 
							map__[x] = {}
						end
						for x = 1, #sc_map do 
							for y = 1, #sc_map[x] do 
								if sc_map[x][y][2] ~= 0 then 
									map__[y][x] = 97
								elseif sc_map[x][y][3] == 1 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][6]*100) -- [id gracza]01
								elseif sc_map[x][y][3] == 3 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][5]*100) -- [id gracza]03
								elseif sc_map[x][y][3] == 843 then
									map__[y][x] = 98 
								elseif sc_map[x][y][3] ~= 0 then
									map__[y][x] = sc_map[x][y][3]
								else
									map__[y][x] = 0
								end
							end
						end
						for h = 1, #sc_heroes do
							local m = sc_heroes[h].owner*100+99
							if sc_heroes[h].owner == sc_local[2] then
								m = 1 
							end
							map__[sc_heroes[h].pos.y][sc_heroes[h].pos.x] = m
						end
						
						--for x = 1, #map__ do local row = ""  for y = 1, #map__[x] do  local add = map__[x][y] if string.len(add) == 1 then add = "  "..add elseif string.len(add) == 2 then add = " "..add end row = row..","..add end print(row) end -- PRINT map__
						local walkable = function(v)
							local id, owner = v, math.floor(v/100)
							if id > 100 then id = v-(math.floor(v/100)*100) end
							if owner == 0 then id = v end
								--id - itemid, owner - building owner
								-- 99 - hero
								-- 98 - wildball
								-- 97 - blocked (tree, bush etc)
							if (owner == sc_local[2] or owner == 0 or isInArray(id, {99, 0}) == true) and isInArray(id, {98, 97}) == false then
								return true
							else
								return false
							end
						end
						--
						local grid = Grid(map__)
						local myFinder = Pathfinder(grid, 'ASTAR', walkable)
						myFinder:setMode("ORTHOGONAL")
						local path = myFinder:getPath(sc_heroes[h].pos.x,sc_heroes[h].pos.y, sc_local[8][1], sc_local[8][2])
						--
						if path ~= nil and sc_heroes[h] ~= nil then -- moving to tower
							local lastStep = {sc_heroes[h].pos.x, sc_heroes[h].pos.y}
							if lastStep_[1] ~= 0 and lastStep_[2] ~= 0 then lastStep = lastStep_ end
							for node, count in path:nodes() do
								if count-1 <= sc_heroes[h].stamina and count ~= 1 then
									local function aiHeroTouch()
										if sc_heroes[h].stamina > 0 then
											st = system.getTimer()
											scHeroTouch( {phase = "ended", target = {hid = sc_heroes[h].id}} )
										end
									end
									local function aiHeroMove(event)
										if sc_heroes[h].stamina > 0 then
											local p = event.source
											heroMove( {phase = "ended", target = {px = p.gx-p.lx, py = p.gy-p.ly}} )
										end
									end
									timer.performWithDelay( 100+checklist.delay, aiHeroTouch)
									local t = timer.performWithDelay( 150+checklist.delay, aiHeroMove)
									t.gx = node:getX()
									t.lx = lastStep[1]
									t.gy = node:getY()
									t.ly = lastStep[2]
									checklist.delay = checklist.delay+100
									lastStep = {node:getX(), node:getY()}
								end
							end
						end
					end
				end
			end
		----------------------------------------------------------------------------------------------------------------------------
		elseif sc_local[7] == 4 then -- hold tower
			for h = 1, #sc_heroes do
				if sc_heroes[h].owner == sc_local[2] then
					local heroPower = 0
					for a = 1, #sc_heroes[h].army do
						heroPower = heroPower + (sc_heroes[h].army[a][2] * sc_heroes[h].army[a][3])
					end
					if heroPower >= 35 then
						--
						local map__ = {} -- prepare grid-map
						local cheroes = {}
						for x = 1, #sc_map do 
							map__[x] = {}
						end
						for x = 1, #sc_map do 
							for y = 1, #sc_map[x] do 
								if sc_map[x][y][2] ~= 0 then 
									map__[y][x] = 97
								elseif sc_map[x][y][3] == 1 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][6]*100) -- [id gracza]01
								elseif sc_map[x][y][3] == 3 then
									map__[y][x] = sc_map[x][y][3]+(sc_map[x][y][5]*100) -- [id gracza]03
								elseif sc_map[x][y][3] == 843 then
									map__[y][x] = 98 
								elseif sc_map[x][y][3] ~= 0 then
									map__[y][x] = sc_map[x][y][3]
								else
									map__[y][x] = 0
								end
							end
						end
						for h = 1, #sc_heroes do
							local m = sc_heroes[h].owner*100+99
							if sc_heroes[h].owner == sc_local[2] then
								m = 1 
							end
							map__[sc_heroes[h].pos.y][sc_heroes[h].pos.x] = m
						end
						
						--for x = 1, #map__ do local row = ""  for y = 1, #map__[x] do  local add = map__[x][y] if string.len(add) == 1 then add = "  "..add elseif string.len(add) == 2 then add = " "..add end row = row..","..add end print(row) end -- PRINT map__
						local walkable = function(v)
							local id, owner = v, math.floor(v/100)
							if id > 100 then id = v-(math.floor(v/100)*100) end
							if owner == 0 then id = v end
								--id - itemid, owner - building owner
								-- 99 - hero
								-- 98 - wildball
								-- 97 - blocked (tree, bush etc)
							if (owner == sc_local[2] or owner == 0 or isInArray(id, {99, 0}) == true) and isInArray(id, {98, 97}) == false then
								return true
							else
								return false
							end
						end
						--
						local grid = Grid(map__)
						local myFinder = Pathfinder(grid, 'ASTAR', walkable)
						myFinder:setMode("ORTHOGONAL")
						local path = myFinder:getPath(sc_heroes[h].pos.x,sc_heroes[h].pos.y, sc_local[8][1], sc_local[8][2])
						--
						if path ~= nil and sc_heroes[h] ~= nil then -- moving to tower
							local lastStep = {sc_heroes[h].pos.x, sc_heroes[h].pos.y}
							if lastStep_[1] ~= 0 and lastStep_[2] ~= 0 then lastStep = lastStep_ end
							for node, count in path:nodes() do
								if count-1 <= sc_heroes[h].stamina and count ~= 1 then
									local function aiHeroTouch()
										if sc_heroes[h].stamina > 0 then
											st = system.getTimer()
											scHeroTouch( {phase = "ended", target = {hid = sc_heroes[h].id}} )
										end
									end
									local function aiHeroMove(event)
										if sc_heroes[h].stamina > 0 then
											local p = event.source
											heroMove( {phase = "ended", target = {px = p.gx-p.lx, py = p.gy-p.ly}} )
										end
									end
									timer.performWithDelay( 100+checklist.delay, aiHeroTouch)
									local t = timer.performWithDelay( 150+checklist.delay, aiHeroMove)
									t.gx = node:getX()
									t.lx = lastStep[1]
									t.gy = node:getY()
									t.ly = lastStep[2]
									checklist.delay = checklist.delay+100
									lastStep = {node:getX(), node:getY()}
								end
							end
						end
					end
				end
			end
		end
		----------------------------------------------------------------------------------------------------------------------------
		timer.performWithDelay( 100+checklist.delay, displayScenario)
		----------------------------------------------------------------------------------------------------------------------------
		-- ending turn
		local function aiScTurn()
			scTurn({phase = "ended"})
		end
		--timer.performWithDelay( 200+checklist.delay, aiScTurn)
	end
end